importPath=string.gsub(getfenv(1)._.Name,"%.ChapterMaint","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
storyPath=string.gsub(importPath,"%.","/").."Stories/"

-- CHAPTER MAINT WINDOW
-- This is where the real meat of the maintenance work gets done. Chapter text, objectives and transitions are defined on this window.
chapterMaint=Turbine.UI.Lotro.Window()
chapterMaint:SetResizable(true)
chapterMaint:SetMinimumSize(640,500)
-- used to define & maintain all of the parts of a chapter, including objectives
-- there are two tabs, the first is general chapter info stored at the chapter level the second is for objectives
if AuthorSettings==nil then AuthorSettings={} end
if AuthorSettings.ChapterMaint==nil then AuthorSettings.ChapterMaint={} end
if AuthorSettings.ChapterMaint.Width==nil then
	AuthorSettings.ChapterMaint.Width=chapterMaint:GetMinimumWidth()/displayWidth
end
if AuthorSettings.ChapterMaint.Height==nil then
	AuthorSettings.ChapterMaint.Height=chapterMaint:GetMinimumHeight()/displayWidth
end
if AuthorSettings.ChapterMaint.Left==nil then
	AuthorSettings.ChapterMaint.Left=(1-AuthorSettings.ChapterMaint.Width)/2
end
if AuthorSettings.ChapterMaint.Top==nil then
	AuthorSettings.ChapterMaint.Top=(1-AuthorSettings.ChapterMaint.Height)/2
end

chapterMaint:SetSize(AuthorSettings.ChapterMaint.Width*displayWidth,AuthorSettings.ChapterMaint.Height*displayHeight)
chapterMaint:SetPosition(AuthorSettings.ChapterMaint.Left*displayWidth,AuthorSettings.ChapterMaint.Top*displayHeight)
chapterMaint:SetZOrder(2)
chapterMaint:SetText(Resource[language][41])

chapterMaint.ChapterLabel=Turbine.UI.Label()
chapterMaint.ChapterLabel:SetParent(chapterMaint)
chapterMaint.ChapterLabel:SetPosition(40,35)
chapterMaint.ChapterName=Turbine.UI.Lotro.TextBox()
chapterMaint.ChapterName:SetParent(chapterMaint)
chapterMaint.ChapterName:SetTop(chapterMaint.ChapterLabel:GetTop())
chapterMaint.ChapterName:SetSelectable(true)
chapterMaint.ChapterName:SetMultiline(false)
chapterMaint.ChapterName.KeyDown=function(sender,args)
	if args.Action==75 then
		chapterMaint.ChapterName.TextChanged()
	end
end
chapterMaint.ChapterName.TextChanged=function()
	if chapterMaint.ChapterName:HasFocus() then
		updateChapterName(chapterMaint.ChapterID,chapterMaint.ChapterName:GetText())
	end
end

chapterMaint.InfoTab=Turbine.UI.Label()
chapterMaint.InfoTab:SetParent(chapterMaint)
chapterMaint.InfoTab:SetLeft(10)
chapterMaint.InfoTab.Selected=true
chapterMaint.InfoTab.Underscore=Turbine.UI.Control()
chapterMaint.InfoTab.Underscore:SetParent(chapterMaint.InfoTab)
chapterMaint.InfoTab.Underscore:SetBlendMode(Turbine.UI.BlendMode.Overlay)
chapterMaint.InfoTab.Underscore:SetLeft(0)
chapterMaint.InfoTab.Underscore:SetHeight(1)
chapterMaint.InfoTab.Underscore:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
chapterMaint.InfoTab.Underscore:SetBackground(resourcePath.."dot.tga")
chapterMaint.InfoTab.MouseClick=function(sender,args)
	chapterMaint.Message:SetText("")
	chapterMaint.InfoTab.Selected=true
	chapterMaint.ObjectiveTab.Selected=false
	chapterMaint.TransitionTab.Selected=false
	chapterMaint.InfoPanel:SetVisible(true)
	chapterMaint.InfoTab.Underscore:SetBackground(resourcePath.."dot.tga")
	chapterMaint.InfoTab:SetForeColor(Settings.TabSelectedColor)
	chapterMaint.ObjectivePanel:SetVisible(false)
	chapterMaint.ObjectiveTab.Underscore:SetBackground(nil)
	chapterMaint.ObjectiveTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.TransitionPanel:SetVisible(false)
	chapterMaint.TransitionTab.Underscore:SetBackground(nil)
	chapterMaint.TransitionTab:SetForeColor(Settings.TabUnSelectedColor)
end

chapterMaint.ObjectiveTab=Turbine.UI.Label()
chapterMaint.ObjectiveTab:SetParent(chapterMaint)
chapterMaint.ObjectiveTab.Selected=false
chapterMaint.ObjectiveTab.Underscore=Turbine.UI.Control()
chapterMaint.ObjectiveTab.Underscore:SetParent(chapterMaint.ObjectiveTab)
chapterMaint.ObjectiveTab.Underscore:SetBlendMode(Turbine.UI.BlendMode.Overlay)
chapterMaint.ObjectiveTab.Underscore:SetLeft(0)
chapterMaint.ObjectiveTab.Underscore:SetHeight(1)
chapterMaint.ObjectiveTab.Underscore:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
chapterMaint.ObjectiveTab.MouseClick=function(sender,args)
	chapterMaint.Message:SetText("")
	chapterMaint.InfoTab.Selected=false
	chapterMaint.ObjectiveTab.Selected=true
	chapterMaint.TransitionTab.Selected=false
	chapterMaint.InfoPanel:SetVisible(false)
	chapterMaint.InfoTab.Underscore:SetBackground(nil)
	chapterMaint.InfoTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.ObjectivePanel:SetVisible(true)
	chapterMaint.ObjectiveTab.Underscore:SetBackground(resourcePath.."dot.tga")
	chapterMaint.ObjectiveTab:SetForeColor(Settings.TabSelectedColor)
	chapterMaint.TransitionPanel:SetVisible(false)
	chapterMaint.TransitionTab.Underscore:SetBackground(nil)
	chapterMaint.TransitionTab:SetForeColor(Settings.TabUnSelectedColor)
end

chapterMaint.TransitionTab=Turbine.UI.Label()
chapterMaint.TransitionTab:SetParent(chapterMaint)
chapterMaint.TransitionTab.Selected=false
chapterMaint.TransitionTab.Underscore=Turbine.UI.Control()
chapterMaint.TransitionTab.Underscore:SetParent(chapterMaint.TransitionTab)
chapterMaint.TransitionTab.Underscore:SetBlendMode(Turbine.UI.BlendMode.Overlay)
chapterMaint.TransitionTab.Underscore:SetLeft(0)
chapterMaint.TransitionTab.Underscore:SetHeight(1)
chapterMaint.TransitionTab.Underscore:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
chapterMaint.TransitionTab.MouseClick=function(sender,args)
	chapterMaint.Message:SetText("")
	chapterMaint.InfoTab.Selected=false
	chapterMaint.ObjectiveTab.Selected=false
	chapterMaint.TransitionTab.Selected=true
	chapterMaint.InfoPanel:SetVisible(false)
	chapterMaint.InfoTab.Underscore:SetBackground(nil)
	chapterMaint.InfoTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.ObjectivePanel:SetVisible(false)
	chapterMaint.ObjectiveTab.Underscore:SetBackground(nil)
	chapterMaint.ObjectiveTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.TransitionPanel:SetVisible(true)
	chapterMaint.TransitionTab.Underscore:SetBackground(resourcePath.."dot.tga")
	chapterMaint.TransitionTab:SetForeColor(Settings.TabSelectedColor)
end

chapterMaint.InfoPanel=Turbine.UI.Control()
chapterMaint.InfoPanel:SetParent(chapterMaint)

chapterMaint.ContentCaption=Turbine.UI.Label()
chapterMaint.ContentCaption:SetParent(chapterMaint.InfoPanel)
chapterMaint.ContentCaption:SetPosition(0,0)
chapterMaint.ContentBack=Turbine.UI.Control() --bogus 1 pixel border for textbox
chapterMaint.ContentBack:SetParent(chapterMaint.InfoPanel)
chapterMaint.ContentBack:SetLeft(0)
chapterMaint.Content=Turbine.UI.ListBox()
chapterMaint.Content:SetParent(chapterMaint.ContentBack)
chapterMaint.Content:SetPosition(1,1)
chapterMaint.Content.LastBlock=nil
chapterMaint.Content.SelectedIndexChanged=function()
	if chapterMaint.Content.LastBlock~=nil then
		chapterMaint.Content.LastBlock:SetBackColor(nil)
	end
	chapterMaint.Content.LastBlock=chapterMaint.Content:GetSelectedItem()
	if chapterMaint.Content.LastBlock~=nil then
		chapterMaint.Content.LastBlock:SetBackColor(Turbine.UI.Color(.05,.05,.1))
	end
end
chapterMaint.Content.MouseClick=function(sender,args)
	if args.Button==2 then
		local x,y=Turbine.UI.Display:GetMousePosition()
		chapterMaint.ContentMenu:ShowMenuAt(x+2,y+15)
	end
end

chapterMaint.ContentVScroll=Turbine.UI.Lotro.ScrollBar()
chapterMaint.ContentVScroll:SetParent(chapterMaint.InfoPanel)
chapterMaint.ContentVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
chapterMaint.ContentVScroll:SetWidth(10)
chapterMaint.Content:SetVerticalScrollBar(chapterMaint.ContentVScroll)

chapterMaint.ContentMenu=Turbine.UI.ContextMenu();
chapterMaint.ContentMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][195]));
chapterMaint.ContentMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][192]));
chapterMaint.ContentMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][193]));
chapterMaint.ContentMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][194]));
chapterMaint.ContentMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][196]));
chapterMaint.ContentMenu:GetItems():Get(1).Click=function(sender,args)
	chapterMaint.MenuIndex=chapterMaint.Content:GetSelectedIndex()
	chapterMaint.Content:Focus()
	SettingQueueCallback(chapterMaint.ContentMoveUp)
end
chapterMaint.ContentMoveUp=function(sourceIndex)
	local sourceIndex=chapterMaint.MenuIndex
	if sourceIndex>1 then
		-- move block up
		destIndex=sourceIndex-1
		chapterMaint.SwapContent(sourceIndex,destIndex)
		chapterMaint.Content:SetSelectedIndex(destIndex)
	else
		chapterMaint.Content:SetSelectedIndex(sourceIndex)
	end
end
chapterMaint.ContentMenu:GetItems():Get(2).Click=function(sender,args)
	chapterMaint.MenuIndex=chapterMaint.Content:GetSelectedIndex()
	chapterMaint.Content:Focus()
	SettingQueueCallback(chapterMaint.ContentNewText)
end
chapterMaint.ContentNewText=function()
	-- create a new text entry AFTER the MenuIndex position
	local newIndex=chapterMaint.MenuIndex+1

	local newWidth=chapterMaint.Content:GetWidth()
	local item
	item=Turbine.UI.TextBox()
	item:SetSelectable(true)
	item:SetForeColor(Settings.FontColor) -- doesn't take effect for multiline textboxes until AFTER box is actually displayed due to bug in textbox controls (see queued call to RefreshColor below)
	item:SetFont(Settings.Font)
	item:SetMultiline(true)
	item:SetText("")
	item.TextChanged=function(sender,args)
		local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
		fontMetric:SetFont(Settings.Font)
		local height=fontMetric:GetTextHeight(sender:GetText(),sender:GetWidth())
		if height<controlHeight then height=controlHeight end
		sender:SetHeight(height)
		authorWindow.SetChangedState(true)
	end
	item.FocusGained=function(sender,args)
		chapterMaint.Content:SetSelectedIndex(sender.Index)
	end
	item.FocusLost=function(sender,args)
		local content=authorStory.Chapters[chapterMaint.ChapterID].Content[sender.Index]
		if content~=nil then
			if authorWindow.CurrLanguage:GetValue()==2 then
				content.TextFR=sender:GetText()
			elseif authorWindow.CurrLanguage:GetValue()==3 then
				content.TextDE=sender:GetText()
			else
				content.Text=sender:GetText()
			end
		end
	end
	item.KeyDown=function(sender,args)
		if args.Action==75 then
			item:TextChanged()
		end
	end
	item.MouseDown=function(sender,args)
		chapterMaint.Content:SetSelectedItem(sender)
	end
	item.MouseClick=function(sender,args)
		if args.Button==2 then
			local x,y=Turbine.UI.Display:GetMousePosition()
			chapterMaint.ContentMenu:ShowMenuAt(x+2,y+15)
		end
	end
	item.Index=newIndex
	item:SetParent(chapterMaint.Content)
	item.Type="Text"
	item.Text=""
	item.FileName=""
	item.Path=""
	item:SetSize(newWidth,32)
	chapterMaint.Content:InsertItem(newIndex,item)
	-- add to authorStory
	local newContent={}
	newContent.Type="Text"
	newContent.Path=""
	newContent.FileName=""
	newContent.TextFR=""
	newContent.TextDE=""
	newContent.Text=""
	table.insert(authorStory.Chapters[chapterMaint.ChapterID].Content,newIndex,newContent)
	-- fix Indexes
	for k=newIndex+1,chapterMaint.Content:GetItemCount() do
		chapterMaint.Content:GetItem(k).Index=k
	end
	chapterMaint.Content:SetSelectedIndex(newIndex)
end
chapterMaint.ContentMenu:GetItems():Get(3).Click=function(sender,args)
	chapterMaint.MenuIndex=chapterMaint.Content:GetSelectedIndex()
	chapterMaint.Content:Focus()
	SettingQueueCallback(chapterMaint.ContentNewImage)
end
chapterMaint.ContentNewImage=function()
	-- create a new image entry AFTER the MenuIndex position
	local newIndex=chapterMaint.MenuIndex+1

	local newWidth=chapterMaint.Content:GetWidth()
	local item
	item=Turbine.UI.Control()
	item.Image=Turbine.UI.Control()
	item.Image:SetParent(item)
	item.Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	item.Image:SetMouseVisible(false)
	item.Image.ImagePath=Settings.DefaultImagePath
	item.Image.FileName=""
	item.Image.File=resourcePath.."ImageError.tga"
	item.Image:SetBackground(resourcePath.."ImageError.tga")
	item.Image:SetSize(32,32)
	item.Image.Width=32
	item.Image.Height=32
	item.Image:SetLeft((newWidth-32)/2)
	item.MouseDoubleClick=function(sender,args)
		chapterMaint.MouseMask:SetMouseVisible(true)
		imageMaint.ShowMaint(sender.Image)
	end
	item.MouseDown=function(sender,args)
		chapterMaint.Content:SetSelectedItem(sender)
	end
	item.MouseClick=function(sender,args)
		if args.Button==2 then
			local x,y=Turbine.UI.Display:GetMousePosition()
			chapterMaint.ContentMenu:ShowMenuAt(x+2,y+15)
		end
	end
	item.Index=newIndex
	item:SetParent(chapterMaint.Content)
	item.Type="Image"
	item.TextFR="Une image"
	item.TextDE="Ein Bild"
	item.Text="An image"
	item.FileName=""
	item.Path=""
	item:SetSize(newWidth,32)
	chapterMaint.Content:InsertItem(newIndex,item)
	-- add to authorStory
	local newContent={}
	newContent.Type="Image"
	newContent.Path=""
	newContent.FileName=""
	newContent.Text="An image"
	table.insert(authorStory.Chapters[chapterMaint.ChapterID].Content,newIndex,newContent)
	-- fix Indexes
	for k=newIndex+1,chapterMaint.Content:GetItemCount() do
		chapterMaint.Content:GetItem(k).Index=k
	end
	chapterMaint.Content:SetSelectedIndex(newIndex)
	item.MouseDoubleClick(item,nil)
end
chapterMaint.ContentMenu:GetItems():Get(4).Click=function(sender,args)
	chapterMaint.MenuIndex=chapterMaint.Content:GetSelectedIndex()
	chapterMaint.Content:Focus()
	-- use callback so focus events fire before action is taken
	SettingQueueCallback(chapterMaint.ContentDelete)
end
chapterMaint.ContentDelete=function()
	-- delete this block
	local sourceIndex=chapterMaint.MenuIndex
	chapterMaint.Content:RemoveItemAt(sourceIndex)
	for k=sourceIndex,chapterMaint.Content:GetItemCount() do
		chapterMaint.Content:GetItem(k).Index=k
	end
	table.remove(authorStory.Chapters[chapterMaint.ChapterID].Content,sourceIndex)
	chapterMaint.Content.LastBlock=nil
end
chapterMaint.ContentMenu:GetItems():Get(5).Click=function(sender,args)
	chapterMaint.MenuIndex=chapterMaint.Content:GetSelectedIndex()
	chapterMaint.Content:Focus()
	SettingQueueCallback(chapterMaint.ContentMoveDown)
end
chapterMaint.ContentMoveDown=function(sourceIndex)
	local sourceIndex=chapterMaint.MenuIndex
	if sourceIndex<chapterMaint.Content:GetItemCount() then
		-- move block down
		destIndex=sourceIndex+1
		chapterMaint.SwapContent(sourceIndex,destIndex)
		chapterMaint.Content:SetSelectedIndex(destIndex)
	else
		chapterMaint.Content:SetSelectedIndex(sourceIndex)
	end
end
chapterMaint.SwapContent=function(sourceIndex,destIndex)
	local sourceItem=chapterMaint.Content:GetItem(sourceIndex)
	local destItem=chapterMaint.Content:GetItem(destIndex)
	sourceItem.Index=destIndex
	destItem.Index=sourceIndex
	chapterMaint.Content:RemoveItemAt(sourceIndex)
	chapterMaint.Content:InsertItem(destIndex,sourceItem)
	--now update authorStory
	local sourceContent=authorStory.Chapters[chapterMaint.ChapterID].Content[sourceIndex]
	local destContent=authorStory.Chapters[chapterMaint.ChapterID].Content[destIndex]
	local tmpType=destContent.Type
	local tmpText=destContent.Text
	local tmpFileName=destContent.FileName
	local tmpPath=destContent.Path
	destContent.Type=sourceContent.Type
	destContent.Text=sourceContent.Text
	destContent.FileName=sourceContent.FileName
	destContent.Path=sourceContent.Path
	sourceContent.Type=tmpType
	sourceContent.Text=tmpText
	sourceContent.FileName=tmpFileName
	sourceContent.Path=tmpPath
end
chapterMaint.ObjectivePanel=Turbine.UI.Control()
chapterMaint.ObjectivePanel:SetParent(chapterMaint)
chapterMaint.ObjectivePanel:SetVisible(false)
chapterMaint.ObjectiveListCaption=Turbine.UI.Label()
chapterMaint.ObjectiveListCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveListCaption:SetPosition(0,0)
chapterMaint.ObjectiveListCaption:SetWidth(300)
chapterMaint.ObjectiveListBorder=Turbine.UI.Control()
chapterMaint.ObjectiveListBorder:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveListBorder:SetWidth(chapterMaint.ObjectiveListCaption:GetWidth())
chapterMaint.ObjectiveList=Turbine.UI.ListBox()
chapterMaint.ObjectiveList:SetParent(chapterMaint.ObjectiveListBorder)
chapterMaint.ObjectiveList:SetPosition(1,1)
chapterMaint.ObjectiveList:SetWidth(chapterMaint.ObjectiveListBorder:GetWidth()-2)
chapterMaint.ObjectiveListVScroll=Turbine.UI.Lotro.ScrollBar()
chapterMaint.ObjectiveListVScroll:SetLeft(chapterMaint.ObjectiveList:GetLeft()+chapterMaint.ObjectiveList:GetWidth())
chapterMaint.ObjectiveListVScroll:SetWidth(10)
chapterMaint.SettingObjective=false
chapterMaint.ObjectiveList.SelectedIndexChanged=function()
	if chapterMaint.ObjectiveList.LastSelected~=nil then
		chapterMaint.ObjectiveList.LastSelected:SetBackColor(nil)
	end
	chapterMaint.ObjectiveList.LastSelected=chapterMaint.ObjectiveList:GetSelectedItem()
	if chapterMaint.ObjectiveList.LastSelected~=nil then
		chapterMaint.SettingObjective=true
		chapterMaint.ObjectiveList.LastSelected:SetBackColor(Turbine.UI.Color(0,.1,.2))
		local objective=authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList.LastSelected.ID]
		local selectedIndex=1
		for index=1,chapterMaint.ObjectiveType.ListData:GetItemCount() do
			if chapterMaint.ObjectiveType.ListData:GetItem(index).DataValue==objective.Type then
				selectedIndex=index
				break
			end
		end
		chapterMaint.ObjectiveType:SetSelectedIndex(selectedIndex)
		chapterMaint.ObjectiveType.SelectedIndexChanged()

		local chapter=objective.NextChapter
		selectedIndex=1
		if chapter~=nil then
			-- find the list item with the value==chapter
			for index=2,chapterMaint.ObjectiveNextChapter.ListData:GetItemCount() do
				if chapterMaint.ObjectiveNextChapter.ListData:GetItem(index).DataValue==chapter then
					selectedIndex=index
					break
				end
			end
		end
		if objective.Type=="Location" then
			for k=1,chapterMaint.ObjectiveRegionList.ListData:GetItemCount() do
				local item=chapterMaint.ObjectiveRegionList.ListData:GetItem(k)
				if item.DataValue==objective.RequiredCount then
					chapterMaint.ObjectiveRegionList:SetSelectedIndex(k)
					break
				end
			end
		elseif objective.Type=="SendChat" or objective.Type=="RecieveChat" then
			-- find chat channel in chat list
			for k=1,chapterMaint.ObjectiveChatList.ListData:GetItemCount() do
				local item=chapterMaint.ObjectiveChatList.ListData:GetItem(k)
				if item.DataValue==objective.RequiredCount then
					chapterMaint.ObjectiveChatList:SetSelectedIndex(k)
					break
				end
			end
		end
		chapterMaint.ObjectiveNextChapter:SetSelectedIndex(selectedIndex)
		chapterMaint.ObjectiveName:SetText(objective.Name)
		if authorWindow.CurrLanguage:GetValue()==2 then
			chapterMaint.ObjectiveText:SetText(objective.TextFR)
		elseif authorWindow.CurrLanguage:GetValue()==3 then
			chapterMaint.ObjectiveText:SetText(objective.TextDE)
		else
			chapterMaint.ObjectiveText:SetText(objective.Text)
		end
		chapterMaint.ObjectiveRequiredCount:SetText(objective.RequiredCount)
		if authorWindow.CurrLanguage:GetValue()==2 then
			chapterMaint.ObjectiveString:SetText(objective.ObjectiveStringFR)
		elseif authorWindow.CurrLanguage:GetValue()==3 then
			chapterMaint.ObjectiveString:SetText(objective.ObjectiveStringDE)
		else
			chapterMaint.ObjectiveString:SetText(objective.ObjectiveString)
		end

		chapterMaint.ObjectiveSetEnabled(true)
		chapterMaint.ObjectiveDelete:SetEnabled(true)
		chapterMaint.ObjectiveOrderUp:SetEnabled((chapterMaint.ObjectiveList:GetSelectedIndex()>1))
		chapterMaint.ObjectiveOrderDown:SetEnabled((chapterMaint.ObjectiveList:GetSelectedIndex()<chapterMaint.ObjectiveList:GetItemCount()))
		chapterMaint.SettingObjective=false
	else
		chapterMaint.ObjectiveSetEnabled(false)
		chapterMaint.ObjectiveDelete:SetEnabled(false)
		chapterMaint.ObjectiveOrderUp:SetEnabled(false)
		chapterMaint.ObjectiveOrderDown:SetEnabled(false)
	end
end
chapterMaint.ObjectiveSetEnabled=function(flag)
	chapterMaint.ObjectiveType:SetEnabled(flag)
	chapterMaint.ObjectiveNextChapter:SetEnabled(flag)
	chapterMaint.ObjectiveName:SetEnabled(flag)
	chapterMaint.ObjectiveText:SetEnabled(flag)
	chapterMaint.ObjectiveRequiredCount:SetEnabled(flag)
	chapterMaint.ObjectiveString:SetEnabled(flag)
end
chapterMaint.ObjectiveNew=Turbine.UI.Lotro.Button()
chapterMaint.ObjectiveNew:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveNew.Click=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	chapterMaint.ObjectiveSetEnabled(true)
	chapterMaint.ObjectiveName:SetText(Resource[language][26])
	-- create a new objective item AFTER the currently selected one (or at end of list if none selected)
	local ID=#authorStory.Chapters[chapterMaint.ChapterID].Objectives+1
	local displayOrder
	if chapterMaint.ObjectiveList:GetSelectedIndex()>0 then
		displayOrder=chapterMaint.ObjectiveList:GetSelectedIndex()+1
	else
		displayOrder=chapterMaint.ObjectiveList:GetItemCount()+1
	end
	-- adjust existing objectives where DisplayOrder>= displayOrder
	for k,v in ipairs(authorStory.Chapters[chapterMaint.ChapterID].Objectives) do
		if v.DisplayOrder>=displayOrder then
			v.DisplayOrder=v.DisplayOrder+1
		end
	end
	table.insert(authorStory.Chapters[chapterMaint.ChapterID].Objectives,{["Name"]=Resource[language][26],["DisplayOrder"]=displayOrder})
	local tmpItem=Turbine.UI.Label()
	tmpItem:SetParent(chapterMaint.ObjectiveList)
	tmpItem.ID=ID
	tmpItem:SetSize(chapterMaint.ObjectiveList:GetWidth(),controlHeight)
	tmpItem:SetFont(Settings.Font)
	tmpItem:SetForeColor(Settings.FontColor)
	tmpItem:SetText(Resource[language][26])
	chapterMaint.ObjectiveList:InsertItem(displayOrder,tmpItem)

	tmpItem=Turbine.UI.Lotro.CheckBox()
	tmpItem:SetParent(chapterMaint.SuccessList)
	tmpItem.ID=ID
	tmpItem:SetSize(chapterMaint.ObjectiveList:GetWidth(),controlHeight)
	tmpItem:SetFont(Settings.Font)
	tmpItem:SetForeColor(Settings.FontColor)
	tmpItem:SetText(Resource[language][26])
	tmpItem.CheckedChanged=function()
		chapterMaint.SuccessList.Changed()
	end
	chapterMaint.SuccessList:InsertItem(displayOrder,tmpItem)

	tmpItem=Turbine.UI.Lotro.CheckBox()
	tmpItem:SetParent(chapterMaint.FailList)
	tmpItem.ID=ID
	tmpItem:SetSize(chapterMaint.ObjectiveList:GetWidth(),controlHeight)
	tmpItem:SetFont(Settings.Font)
	tmpItem:SetForeColor(Settings.FontColor)
	tmpItem:SetText(Resource[language][26])
	tmpItem.CheckedChanged=function()
		chapterMaint.FailList.Changed()
	end
	chapterMaint.FailList:InsertItem(displayOrder,tmpItem)
	chapterMaint.ObjectiveList:SetSelectedIndex(displayOrder)
	-- add to Storyboard
	if Storyboard.Chapters~=nil and Storyboard.Chapters[chapterMaint.ChapterID]~=nil then
		local chapter=Storyboard.Chapters[chapterMaint.ChapterID]
		chapter.AddObjective(Resource[language][26],nil,ID)
			chapter:SetWidth(chapter.CalcWidth())
			chapter.RefreshLayout()
			chapter.RefreshTransitions()
	end
end

chapterMaint.ObjectiveDelete=Turbine.UI.Lotro.Button()
chapterMaint.ObjectiveDelete:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveDelete.Click=function()
	local ID=chapterMaint.ObjectiveList:GetSelectedItem().ID
	local removeIndex=chapterMaint.ObjectiveList:GetSelectedIndex()
	local displayOrder=authorStory.Chapters[chapterMaint.ChapterID].Objectives[ID].DisplayOrder
	local chapter=authorStory.Chapters[chapterMaint.ChapterID]
	-- remove the objective from authorStory
	table.remove(authorStory.Chapters[chapterMaint.ChapterID].Objectives,ID)
	-- remove the objective from the list
	chapterMaint.ObjectiveList:RemoveItemAt(removeIndex)
	-- fix SuccessCondition/FailCondition
	if authorStory.Chapters[chapterMaint.ChapterID].SuccessCondition~=nil then
		local remove
		for k,v in ipairs(authorStory.Chapters[chapterMaint.ChapterID].SuccessCondition) do
			if v==ID then remove=k end
			if v>ID then authorStory.Chapters[chapterMaint.ChapterID].SuccessCondition[k]=v-1 end
		end
		if remove~=nil then table.remove(authorStory.Chapters[chapterMaint.ChapterID].SuccessCondition,remove) end
	end
	if authorStory.Chapters[chapterMaint.ChapterID].FailCondition~=nil then
		local remove
		for k,v in ipairs(authorStory.Chapters[chapterMaint.ChapterID].FailCondition) do
			if v==ID then remove=k end
			if v>ID then authorStory.Chapters[chapterMaint.ChapterID].FailCondition[k]=v-1 end
		end
		if remove~=nil then table.remove(authorStory.Chapters[chapterMaint.ChapterID].FailCondition,remove) end
	end
	
	-- fix the DisplayOrder for entries where DisplayOrder>displayOrder
	for k,v in ipairs(authorStory.Chapters[chapterMaint.ChapterID].Objectives) do
		if v.DisplayOrder>displayOrder then
			v.DisplayOrder=v.DisplayOrder-1
		end
	end
	chapterMaint.SuccessList:RemoveItemAt(removeIndex)
	chapterMaint.FailList:RemoveItemAt(removeIndex)

	-- need to update .ID for all lists that no longer have this entry
	for k=1,chapterMaint.ObjectiveList:GetItemCount() do
		local oldID=chapterMaint.ObjectiveList:GetItem(k).ID
		if oldID>ID then
			chapterMaint.ObjectiveList:GetItem(k).ID=oldID-1
			chapterMaint.SuccessList:GetItem(k).ID=oldID-1
			chapterMaint.FailList:GetItem(k).ID=oldID-1
		end
	end

	chapterMaint.ObjectiveList:SetSelectedIndex(0)
	chapterMaint.ObjectiveSetEnabled(false)
	-- clear the controls
	chapterMaint.ObjectiveType:SetSelectedIndex(1)
	chapterMaint.ObjectiveNextChapter:SetSelectedIndex(1)
	chapterMaint.ObjectiveName:SetText("")
	chapterMaint.ObjectiveText:SetText("")
	chapterMaint.ObjectiveOrderUp:SetEnabled(false)
	chapterMaint.ObjectiveOrderDown:SetEnabled(false)
	chapterMaint.ObjectiveRequiredCount:SetText("")
	chapterMaint.ObjectiveString:SetText("")
	-- remove from Storyboard
	if Storyboard.Chapters~=nil and Storyboard.Chapters[chapterMaint.ChapterID]~=nil then
		local obj
		local index
		for k=1,Storyboard.Chapters[chapterMaint.ChapterID].Objectives:GetItemCount() do
			obj=Storyboard.Chapters[chapterMaint.ChapterID].Objectives:GetItem(k)
			if obj.ID==ID then
				index=k
			end
			if obj.ID>ID then
				obj.ID=obj.ID-1
			end
		end
		if index~=nil then
			obj=Storyboard.Chapters[chapterMaint.ChapterID].Objectives:GetItem(index)
			if Storyboard.LastSelected==obj then Storyboard.LastSelected=nil end
			if obj.Transition~=nil then
				obj.Transition:SetVisible(false)
				obj.Transition=nil
			end
			obj:SetVisible(false)
			Storyboard.Chapters[chapterMaint.ChapterID].Objectives:RemoveItemAt(index)
			Storyboard.Chapters[chapterMaint.ChapterID]:SetWidth(Storyboard.Chapters[chapterMaint.ChapterID].CalcWidth())
			Storyboard.Chapters[chapterMaint.ChapterID].RefreshLayout()
			Storyboard.Chapters[chapterMaint.ChapterID].RefreshTransitions()
		end
	end
	chapterMaint.ObjectiveDelete:SetEnabled(chapterMaint.ObjectiveList:GetSelectedIndex()>0)
end

chapterMaint.ObjectiveTypeCaption=Turbine.UI.Label()
chapterMaint.ObjectiveTypeCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveType=DropDownList()
chapterMaint.ObjectiveType:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveType:AddItem(Resource[language][96],nil)
chapterMaint.ObjectiveType:AddItem(Resource[language][98],"Button")
chapterMaint.ObjectiveType:AddItem(Resource[language][99],"Target")
chapterMaint.ObjectiveType:AddItem(Resource[language][118],"DefeatX")
chapterMaint.ObjectiveType:AddItem(Resource[language][119],"AcquireX")
--chapterMaint.ObjectiveType:AddItem(Resource[language][120],"Skill") -- how to detect skill use if it doesn't cause an effect or chat msg? not all classes have all skills...
chapterMaint.ObjectiveType:AddItem(Resource[language][121],"Equip")
--chapterMaint.ObjectiveType:AddItem(Resource[language][122],"Emote") -- for now this can be handled as a special case of ReceiveChat
--chapterMaint.ObjectiveType:AddItem(Resource[language][123],"SendChat")
chapterMaint.ObjectiveType:AddItem(Resource[language][124],"ReceiveChat")
chapterMaint.ObjectiveType:AddItem(Resource[language][130],"Effect")
chapterMaint.ObjectiveType:AddItem(Resource[language][204],"Location")
chapterMaint.ObjectiveType:SetZOrder(4)
chapterMaint.ObjectiveType.SelectedIndexChanged=function()
	local type=chapterMaint.ObjectiveType:GetValue()
	chapterMaint.CaptureTarget:SetVisible(false)
	chapterMaint.CaptureLocation:SetVisible(false)
	chapterMaint.ObjectiveChatList:SetVisible(false)
	chapterMaint.ObjectiveRegionList:SetVisible(false)
	chapterMaint.ObjectiveString:SetAllowDrop(false)
	chapterMaint.CaptureEffect:SetVisible(false)
	if type=="Button" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(false)
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][103]..":")
	elseif type=="Target" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(false)
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][104]..":")
		chapterMaint.CaptureTarget:SetVisible(true)
	elseif type=="DefeatX" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(true)
		chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][94]..":")
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][104]..":")
		chapterMaint.CaptureTarget:SetVisible(true)
	elseif type=="AcquireX" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(true)
		chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][94]..":")
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][126]..":")
		chapterMaint.ObjectiveString:SetAllowDrop(true)
	elseif type=="Skill" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(false)
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][127]..":")
		chapterMaint.ObjectiveString:SetAllowDrop(true)
	elseif type=="Equip" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(false)
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][126]..":")
		chapterMaint.ObjectiveString:SetAllowDrop(true)
	elseif type=="Emote" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(false)
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][128]..":")
	elseif type=="SendChat" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(true)
		chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][125]..":")
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][129]..":")
		chapterMaint.ObjectiveChatList:SetVisible(true)
		if not chapterMaint.SettingObjective then
			chapterMaint.ObjectiveChatList.SelectedIndexChanged() -- resynch value
		end
	elseif type=="ReceiveChat" then
		chapterMaint.ObjectiveRequiredCount:SetVisible(true)
		chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][125]..":")
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][129]..":")
		chapterMaint.ObjectiveChatList:SetVisible(true)
		if not chapterMaint.SettingObjective then
			chapterMaint.ObjectiveChatList.SelectedIndexChanged() -- resynch value
		end
	elseif type=="Effect" then
		-- disable RequiredCount and ObjectiveString
		chapterMaint.ObjectiveRequiredCount:SetVisible(false)
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][131]..":")
		chapterMaint.CaptureEffect:SetVisible(true)
	elseif type=="Location" then
		-- make RequiredCount
		chapterMaint.ObjectiveRequiredCount:SetVisible(true)
		chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][202]..":")
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][203]..":")
		chapterMaint.CaptureLocation:SetVisible(true)
		chapterMaint.ObjectiveRegionList:SetVisible(true)
		if not chapterMaint.SettingObjective then
			chapterMaint.ObjectiveRegionList.SelectedIndexChanged() -- resynch value
		end
	else
		chapterMaint.ObjectiveRequiredCount:SetVisible(true)
		chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][94]..":")
		chapterMaint.ObjectiveString:SetVisible(true)
		chapterMaint.ObjectiveStringCaption:SetText(Resource[language][95]..":")
	end
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].Type=type
	authorWindow.SetChangedState(true)
end

chapterMaint.ObjectiveNextChapterCaption=Turbine.UI.Label()
chapterMaint.ObjectiveNextChapterCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveNextChapter=DropDownList()
chapterMaint.ObjectiveNextChapter:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveNextChapter:SetZOrder(3)
authorLoadObjChapterList=function()
	chapterMaint.ObjectiveNextChapter:ClearList()
	chapterMaint.SuccessNextChapter:ClearList()
	chapterMaint.FailNextChapter:ClearList()
	chapterMaint.ObjectiveNextChapter:AddItem(Resource[language][100],nil)
	chapterMaint.SuccessNextChapter:AddItem(Resource[language][109],nil)
	chapterMaint.FailNextChapter:AddItem(Resource[language][109],nil)
	chapterMaint.ObjectiveNextChapter:AddItem(Resource[language][97],-1)
	chapterMaint.SuccessNextChapter:AddItem(Resource[language][97],-1)
	chapterMaint.FailNextChapter:AddItem(Resource[language][97],-1)
	local tmpTable={}
	for k,v in ipairs(authorStory.Chapters) do
		-- add name,ID and display order to tmptable
		table.insert(tmpTable,{["ID"]=k,["Name"]=v.Name,["DisplayOrder"]=v.DisplayOrder})
	end
	table.sort(tmpTable,function(arg1,arg2) if arg1.DisplayOrder<arg2.DisplayOrder then return true end end)
	for k,v in ipairs(tmpTable) do
		chapterMaint.ObjectiveNextChapter:AddItem(v.Name,v.ID)
		chapterMaint.SuccessNextChapter:AddItem(v.Name,v.ID)
		chapterMaint.FailNextChapter:AddItem(v.Name,v.ID)
	end
end
chapterMaint.ObjectiveNextChapter.SelectedIndexChanged=function()
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].NextChapter=chapterMaint.ObjectiveNextChapter:GetValue()
	authorWindow.SetChangedState(true)
	-- update transition on Storyboard
	if Storyboard.Chapters~=nil and Storyboard.Chapters[chapterMaint.ChapterID]~=nil then
		local obj=Storyboard.Chapters[chapterMaint.ChapterID].Objectives:GetItem(chapterMaint.ObjectiveList:GetSelectedItem().ID)
		if obj~=nil then
			-- remove the old transition if any
			if obj.Transition~=nil then
				obj.Transition:SetVisible(false)
				obj.Transition=nil
			end
			-- add the new one
			obj.Transition=Storyboard.ShowTransition(Storyboard.Chapters[chapterMaint.ChapterID],Storyboard.Chapters[chapterMaint.ObjectiveNextChapter:GetValue()])
			obj.NextChapter=chapterMaint.ObjectiveNextChapter:GetValue()
		end
		if chapterMaint.ObjectiveNextChapter:GetValue()~=nil and chapterMaint.ObjectiveNextChapter:GetValue()>0 then
			if Storyboard.Chapters[chapterMaint.ObjectiveNextChapter:GetValue()]~=nil then
			end
		end
	end
end
chapterMaint.ObjectiveNameCaption=Turbine.UI.Label()
chapterMaint.ObjectiveNameCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveName=Turbine.UI.Lotro.TextBox()
chapterMaint.ObjectiveName:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveName:SetSelectable(true)
chapterMaint.ObjectiveName:SetMultiline(false)
chapterMaint.ObjectiveName.KeyDown=function(sender,args)
	if args.Action==75 then
		chapterMaint.ObjectiveName.TextChanged()
	end
end
chapterMaint.ObjectiveName.TextChanged=function()
	updateObjectiveName(chapterMaint.ChapterID,chapterMaint.ObjectiveList:GetSelectedItem().ID,chapterMaint.ObjectiveName:GetText())
end
chapterMaint.ObjectiveTextCaption=Turbine.UI.Label()
chapterMaint.ObjectiveTextCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveTextBorder=Turbine.UI.Control()
chapterMaint.ObjectiveTextBorder:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveText=Turbine.UI.TextBox()
chapterMaint.ObjectiveText:SetParent(chapterMaint.ObjectiveTextBorder)
chapterMaint.ObjectiveText:SetSelectable(true)
chapterMaint.ObjectiveText:SetPosition(1,1)
chapterMaint.ObjectiveText.TextChanged=function()
	if authorWindow.CurrLanguage:GetValue()==2 then
		authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].TextFR=chapterMaint.ObjectiveText:GetText()
	elseif authorWindow.CurrLanguage:GetValue()==3 then
		authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].TextDE=chapterMaint.ObjectiveText:GetText()
	else
		authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].Text=chapterMaint.ObjectiveText:GetText()
	end
	authorWindow.SetChangedState(true)
end
chapterMaint.ObjectiveTextVScroll=Turbine.UI.Lotro.ScrollBar()
chapterMaint.ObjectiveTextVScroll:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveTextVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
chapterMaint.ObjectiveTextVScroll:SetWidth(10)
chapterMaint.ObjectiveText:SetVerticalScrollBar(chapterMaint.ObjectiveTextVScroll)

chapterMaint.ObjectiveDisplayOrderCaption=Turbine.UI.Label()
chapterMaint.ObjectiveDisplayOrderCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveOrderUp=Turbine.UI.Lotro.Button()
chapterMaint.ObjectiveOrderUp:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveOrderUp.Click=function()
	local sourceIndex=chapterMaint.ObjectiveList:GetSelectedIndex()
	local source=chapterMaint.ObjectiveList:GetSelectedItem()
	local sourceID=source.ID
	local dest=chapterMaint.ObjectiveList:GetItem(sourceIndex-1)
	local destID=dest.ID
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[destID].DisplayOrder=authorStory.Chapters[chapterMaint.ChapterID].Objectives[destID].DisplayOrder+1
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[sourceID].DisplayOrder=authorStory.Chapters[chapterMaint.ChapterID].Objectives[sourceID].DisplayOrder-1
	-- fix ObjectiveList
	chapterMaint.ObjectiveList:RemoveItemAt(sourceIndex)
	chapterMaint.ObjectiveList:InsertItem(sourceIndex-1,source)
	chapterMaint.ObjectiveList.LastSelected=nil
	chapterMaint.ObjectiveList:SetSelectedIndex(sourceIndex-1)
	-- fix SuccessList
	source=chapterMaint.SuccessList:GetItem(sourceIndex)
	chapterMaint.SuccessList:RemoveItemAt(sourceIndex)
	chapterMaint.SuccessList:InsertItem(sourceIndex-1,source)
	-- fix FailList
	source=chapterMaint.FailList:GetItem(sourceIndex)
	chapterMaint.FailList:RemoveItemAt(sourceIndex)
	chapterMaint.FailList:InsertItem(sourceIndex-1,source)
end

chapterMaint.ObjectiveOrderDown=Turbine.UI.Lotro.Button()
chapterMaint.ObjectiveOrderDown:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveOrderDown.Click=function()
	local sourceIndex=chapterMaint.ObjectiveList:GetSelectedIndex()
	local source=chapterMaint.ObjectiveList:GetSelectedItem()
	local sourceID=source.ID
	local dest=chapterMaint.ObjectiveList:GetItem(sourceIndex+1)
	local destID=dest.ID
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[destID].DisplayOrder=authorStory.Chapters[chapterMaint.ChapterID].Objectives[destID].DisplayOrder-1
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[sourceID].DisplayOrder=authorStory.Chapters[chapterMaint.ChapterID].Objectives[sourceID].DisplayOrder+1
	-- fix ObjectiveList
	chapterMaint.ObjectiveList:RemoveItemAt(sourceIndex)
	chapterMaint.ObjectiveList:InsertItem(sourceIndex+1,source)
	chapterMaint.ObjectiveList.LastSelected=nil
	chapterMaint.ObjectiveList:SetSelectedIndex(sourceIndex+1)
	-- fix SuccessList
	source=chapterMaint.SuccessList:GetItem(sourceIndex)
	chapterMaint.SuccessList:RemoveItemAt(sourceIndex)
	chapterMaint.SuccessList:InsertItem(sourceIndex+1,source)
	-- fix FailList
	source=chapterMaint.FailList:GetItem(sourceIndex)
	chapterMaint.FailList:RemoveItemAt(sourceIndex)
	chapterMaint.FailList:InsertItem(sourceIndex+1,source)
end

chapterMaint.ObjectiveRequiredCountCaption=Turbine.UI.Label()
chapterMaint.ObjectiveRequiredCountCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveRequiredCount=Turbine.UI.Lotro.TextBox()
chapterMaint.ObjectiveRequiredCount:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveRequiredCount:SetSelectable(true)
chapterMaint.ObjectiveRequiredCount:SetMultiline(false)
chapterMaint.ObjectiveRequiredCount.TextChanged=function()
	authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].RequiredCount=tonumber(chapterMaint.ObjectiveRequiredCount:GetText())
	authorWindow.SetChangedState(true)
end

chapterMaint.ObjectiveChatList=DropDownList()
chapterMaint.ObjectiveChatList:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveChatList:SetVisible(false)
chapterMaint.ObjectiveChatList:SetZOrder(2)
chapterMaint.ObjectiveChatList:AddItem("<ANY>",0)
fillChatList=function()
	chapterMaint.ObjectiveChatList:ClearList()
	local tmpList={}
	for k,v in pairs(ChannelName[language]) do
		table.insert(tmpList,{["name"]=v,["channel"]=k})
	end
	table.sort(tmpList,function(arg1,arg2) if arg1.name<arg2.name then return true end end)
	for k,v in ipairs(tmpList) do
		chapterMaint.ObjectiveChatList:AddItem(v.name.." ("..tostring(v.channel)..")",v.channel)
	end
end
fillChatList()
chapterMaint.ObjectiveChatList.SelectedIndexChanged=function()
	chapterMaint.ObjectiveRequiredCount:SetText(chapterMaint.ObjectiveChatList:GetValue())
	chapterMaint.ObjectiveRequiredCount.TextChanged()
end

chapterMaint.ObjectiveRegionList=DropDownList()
chapterMaint.ObjectiveRegionList:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveRegionList:SetVisible(false)
chapterMaint.ObjectiveRegionList:SetZOrder(2)
chapterMaint.ObjectiveRegionList:AddItem(Resource[language][205],1)
chapterMaint.ObjectiveRegionList:AddItem(Resource[language][206],2)
chapterMaint.ObjectiveRegionList:AddItem(Resource[language][207],3)
chapterMaint.ObjectiveRegionList:AddItem(Resource[language][208],4)
chapterMaint.ObjectiveRegionList:SetSelectedIndex(1)
chapterMaint.ObjectiveRegionList.SelectedIndexChanged=function()
	chapterMaint.ObjectiveRequiredCount:SetText(tostring(chapterMaint.ObjectiveRegionList:GetValue()))
	chapterMaint.ObjectiveRequiredCount.TextChanged()
end

chapterMaint.ObjectiveStringCaption=Turbine.UI.Label()
chapterMaint.ObjectiveStringCaption:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveStringCaption:SetText(Resource[language][95]..":")
chapterMaint.ObjectiveString=Turbine.UI.Lotro.TextBox()
chapterMaint.ObjectiveString:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.ObjectiveString:SetSelectable(true)
chapterMaint.ObjectiveString:SetMultiline(false)
chapterMaint.ObjectiveString.TextChanged=function()
	if authorWindow.CurrLanguage:GetValue()==2 then
		authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].ObjectiveStringFR=chapterMaint.ObjectiveString:GetText()
	elseif authorWindow.CurrLanguage:GetValue()==3 then
		authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].ObjectiveStringDE=chapterMaint.ObjectiveString:GetText()
	else
		authorStory.Chapters[chapterMaint.ChapterID].Objectives[chapterMaint.ObjectiveList:GetSelectedItem().ID].ObjectiveString=chapterMaint.ObjectiveString:GetText()
	end
	authorWindow.SetChangedState(true)
end
chapterMaint.ObjectiveString.DragDrop=function(sender,args)
	local ddi=args.DragDropInfo
	if ddi~=nil then
		local sc=ddi:GetShortcut()
		local type=chapterMaint.ObjectiveType:GetValue()
		if sc~=nil then
			local scType=sc:GetType()
			if scType==Turbine.UI.Lotro.ShortcutType.Item and (type=="AcquireX" or type=="Equip") then
				-- we track items by name even though that's not really great, we can't check item IDs in inventory
				chapterMaint.ObjectiveString:SetText(tostring(sc:GetItem():GetName()))
				chapterMaint.ObjectiveString.TextChanged()
			elseif scType==Turbine.UI.Lotro.ShortcutType.Skill and type=="Skill" then
				-- not sure this is worth capturing since the Skill type will probably never get implemented (no way to reliably catch all skill usage)
				local data=sc:GetData()
				if data~=nil then
					chapterMaint.ObjectiveString:SetText(tostring(data))
					chapterMaint.ObjectiveString.TextChanged()
				end
			end
		end
	end
end
-- target capture control
chapterMaint.CaptureTarget=Turbine.UI.Control()
chapterMaint.CaptureTarget:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.CaptureTarget:SetSize(12,12)
chapterMaint.CaptureTarget:SetBlendMode(Turbine.UI.BlendMode.Overlay)
chapterMaint.CaptureTarget:SetBackground(0x41007f48)
chapterMaint.CaptureTarget:SetVisible(false)
chapterMaint.CaptureTarget.MouseClick=function()
	local target=localPlayer:GetTarget()
	if target~=nil then
		chapterMaint.ObjectiveString:SetText(target:GetName())
		chapterMaint.ObjectiveString.TextChanged()
	end
end

-- location capture control
chapterMaint.CaptureLocation=Turbine.UI.Control()
chapterMaint.CaptureLocation:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.CaptureLocation:SetSize(12,12)
chapterMaint.CaptureLocation:SetVisible(false)
chapterMaint.CaptureLocationQS=Turbine.UI.Lotro.Quickslot()
chapterMaint.CaptureLocationQS:SetParent(chapterMaint.CaptureLocation)
chapterMaint.CaptureLocationQS:SetShortcut()
chapterMaint.CaptureLocationQS:SetAllowDrop(false)
chapterMaint.CaptureLocationQS.Cmd="/loc"
locale=Turbine.Engine:GetLanguage()
if locale==Turbine.Language.French then
	chapterMaint.CaptureLocationQS.Cmd="/emp"
elseif locale==Turbine.Language.German then
	chapterMaint.CaptureLocationQS.Cmd="/pos"
end
chapterMaint.CaptureLocationQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, chapterMaint.CaptureLocationQS.Cmd));
chapterMaint.CaptureLocationQS.DragDrop=function()
	-- reestablish the shortcut if the user accidentally drags it onto itself which wipes it out even if drag/drop is disabled
	chapterMaint.CaptureLocationQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, chapterMaint.CaptureLocationQS.Cmd));
end
chapterMaint.CaptureLocationImage=Turbine.UI.Control()
chapterMaint.CaptureLocationImage:SetParent(chapterMaint.CaptureLocation)
chapterMaint.CaptureLocationImage:SetSize(12,12)
chapterMaint.CaptureLocationImage:SetBlendMode(Turbine.UI.BlendMode.Overlay)
chapterMaint.CaptureLocationImage:SetBackground(0x41007f48)
chapterMaint.CaptureLocationImage:SetMouseVisible(false)
chapterMaint.CaptureLocationQS.Enabled=false
chapterMaint.CaptureLocationQS.MouseEnter=function()
	chapterMaint.CaptureLocationQS.Enabled=true
end
chapterMaint.CaptureLocationQS.MouseLeave=function()
	chapterMaint.CaptureLocationQS.Enabled=false
end

chapterMaint.CaptureEffect=Turbine.UI.Control()
chapterMaint.CaptureEffect:SetParent(chapterMaint.ObjectivePanel)
chapterMaint.CaptureEffect:SetSize(12,12)
chapterMaint.CaptureEffect:SetBlendMode(Turbine.UI.BlendMode.Overlay)
chapterMaint.CaptureEffect:SetBackground(0x41007f48)
chapterMaint.CaptureEffect:SetVisible(false)
chapterMaint.CaptureEffect.MouseClick=function()
	effectSelect.Filling=true
	effectSelect.FillEffectList()
	effectSelect:SetVisible(true)
	SettingQueueCallback(effectSelect.Filled)
	chapterMaint.MouseMask:SetMouseVisible(true)
end
-- effectSelect
effectSelect=Turbine.UI.Control()
effectSelect:SetParent(chapterMaint) -- has to be a child of chapterMaint to appear above mousemask
effectSelect:SetSize(400,400)
effectSelect:SetZOrder(3)
effectSelect:SetBackColor(Settings.TrimColor)
effectSelect.Caption=Turbine.UI.Label()
effectSelect.Caption:SetParent(effectSelect)
effectSelect.Caption:SetBackColor(Settings.BackColor)
effectSelect.Caption:SetForeColor(Settings.LabelColor)
effectSelect.EffectList=Turbine.UI.ListBox()
effectSelect.EffectList:SetParent(effectSelect)
effectSelect.EffectList:SetBackColor(Settings.BackColor)
effectSelect.VScroll=Turbine.UI.Lotro.ScrollBar()
effectSelect.VScroll:SetParent(effectSelect)
effectSelect.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
effectSelect.VScroll:SetWidth(10)
effectSelect.EffectList:SetVerticalScrollBar(effectSelect.VScroll)
effectSelect.Filled=function()
	effectSelect.Filling=false
end

effectSelect.FillEffectList=function()
	local tmpLang=language
	local tmpList={}
	effectSelect.EffectList:ClearItems()
	for icon,tmpVal in pairs(KnownEffects) do
		if tmpVal[tmpLang]~=nil then
			for index, name in ipairs(tmpVal[tmpLang]) do
				-- add tmplist entry
				table.insert(tmpList,{["Icon"]=icon,["Name"]=name})
			end
		end
	end
	table.sort(tmpList,function(arg1,arg2) if arg1.Name<arg2.Name then return true end end)
	local curSelection=chapterMaint.ObjectiveString:GetText()
	local curIndex
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local rowHeight=controlHeight
	if rowHeight<32 then rowHeight=32 end
	for k,v in ipairs(tmpList) do
		-- list is now alphabetized by name
		local item=Turbine.UI.Control()
		item.Index=k
		item:SetBackColor(Settings.BackColor)
		item:SetSize(effectSelect.EffectList:GetWidth(),rowHeight)
		item.Label=Turbine.UI.Label()
		item.Label:SetParent(item)
		item.Label:SetSize(item:GetWidth()-42,rowHeight)
		item.Label:SetForeColor(Settings.FontColor)
		item.Label:SetFont(Settings.Font)
		item.Label:SetText(v.Name)
		item.Label:SetMultiline(false)
		item.Label:SetMouseVisible(false)
		item.Icon=Turbine.UI.Control()
		item.Icon:SetParent(item)
		item.Icon:SetSize(32,32)
		item.Icon:SetLeft(item.Label:GetWidth())
		item.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		item.Icon:SetBackground(v.Icon)
		item.Icon:SetMouseVisible(false)
		item.MouseClick=function(sender,args)
			 -- we want to allow selecting the already selected item
			effectSelect.EffectList:SetSelectedIndex(sender.Index)
			effectSelect.EffectList:SelectedIndexChanged()
		end
		if v.Name==curSelection then curIndex=k end
		effectSelect.EffectList:AddItem(item)
	end
	if curIndex~=nil then
		effectSelect.EffectList:SetSelectedIndex(curIndex)
	end
end
effectSelect.EffectList.SelectedIndexChanged=function()
	if not effectSelect.Filling then
		local index=effectSelect.EffectList:GetSelectedIndex()
		if index~=nil and index>0 then
			local item=effectSelect.EffectList:GetSelectedItem()
			chapterMaint.ObjectiveString:SetText(item.Label:GetText())
			SettingQueueCallback(chapterMaint.HideEffectSelect)
		end
	end
end
effectSelect:SetVisible(false)

chapterMaint.TransitionPanel=Turbine.UI.Control()
chapterMaint.TransitionPanel:SetParent(chapterMaint)
chapterMaint.TransitionPanel:SetVisible(false)

chapterMaint.SuccessNextCaption=Turbine.UI.Label()
chapterMaint.SuccessNextCaption:SetParent(chapterMaint.TransitionPanel)
chapterMaint.SuccessNextChapter=DropDownList()
chapterMaint.SuccessNextChapter:SetParent(chapterMaint.TransitionPanel)
chapterMaint.SuccessNextChapter:SetFont(Settings.Font)
chapterMaint.SuccessNextChapter:SetZOrder(1)
chapterMaint.SuccessNextChapter.SelectedIndexChanged=function()
	authorStory.Chapters[chapterMaint.ChapterID].SuccessNextChapter=chapterMaint.SuccessNextChapter:GetValue()
	-- update Storyboard
	if Storyboard.Chapters~=nil and Storyboard.Chapters[chapterMaint.ChapterID]~=nil then
		Storyboard.Chapters[chapterMaint.ChapterID].SuccessNextChapter=chapterMaint.SuccessNextChapter:GetValue()
		Storyboard.Chapters[chapterMaint.ChapterID].RefreshTransitions()
	end
	authorWindow.SetChangedState(true)
end
chapterMaint.SuccessCaption=Turbine.UI.Label()
chapterMaint.SuccessCaption:SetParent(chapterMaint.TransitionPanel)
chapterMaint.SuccessBorder=Turbine.UI.Control()
chapterMaint.SuccessBorder:SetParent(chapterMaint.TransitionPanel)
chapterMaint.SuccessList=Turbine.UI.ListBox()
chapterMaint.SuccessList:SetParent(chapterMaint.SuccessBorder)
chapterMaint.SuccessList:SetPosition(1,1)
chapterMaint.SuccessVScroll=Turbine.UI.Lotro.ScrollBar()
chapterMaint.SuccessVScroll:SetParent(chapterMaint.TransitionPanel)
chapterMaint.SuccessVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
chapterMaint.SuccessVScroll:SetWidth(10)
chapterMaint.SuccessList:SetVerticalScrollBar(chapterMaint.SuccessVScroll)
chapterMaint.SuccessList.Changed=function()
	local list={}
	for k=1,chapterMaint.SuccessList:GetItemCount() do
		local item=chapterMaint.SuccessList:GetItem(k)
		if item:IsChecked() then
			table.insert(list,item.ID)
		end
	end
	if #list>0 then
		authorStory.Chapters[chapterMaint.ChapterID].SuccessCondition=list
	else
		authorStory.Chapters[chapterMaint.ChapterID].SuccessCondition=nil
	end
	authorWindow.SetChangedState(true)
end

chapterMaint.FailNextCaption=Turbine.UI.Label()
chapterMaint.FailNextCaption:SetParent(chapterMaint.TransitionPanel)
chapterMaint.FailNextChapter=DropDownList()
chapterMaint.FailNextChapter:SetParent(chapterMaint.TransitionPanel)
chapterMaint.FailNextChapter:SetFont(Settings.Font)
chapterMaint.FailNextChapter:SetZOrder(1)
chapterMaint.FailNextChapter.SelectedIndexChanged=function()
	authorStory.Chapters[chapterMaint.ChapterID].FailNextChapter=chapterMaint.FailNextChapter:GetValue()
	-- update Storyboard
	if Storyboard.Chapters~=nil and Storyboard.Chapters[chapterMaint.ChapterID]~=nil then
		Storyboard.Chapters[chapterMaint.ChapterID].FailNextChapter=chapterMaint.FailNextChapter:GetValue()
		Storyboard.Chapters[chapterMaint.ChapterID].RefreshTransitions()
	end
	authorWindow.SetChangedState(true)
end
chapterMaint.FailCaption=Turbine.UI.Label()
chapterMaint.FailCaption:SetParent(chapterMaint.TransitionPanel)
chapterMaint.FailBorder=Turbine.UI.Control()
chapterMaint.FailBorder:SetParent(chapterMaint.TransitionPanel)
chapterMaint.FailList=Turbine.UI.ListBox()
chapterMaint.FailList:SetParent(chapterMaint.FailBorder)
chapterMaint.FailList:SetPosition(1,1)
chapterMaint.FailVScroll=Turbine.UI.Lotro.ScrollBar()
chapterMaint.FailVScroll:SetParent(chapterMaint.TransitionPanel)
chapterMaint.FailVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
chapterMaint.FailVScroll:SetWidth(10)
chapterMaint.FailList:SetVerticalScrollBar(chapterMaint.FailVScroll)
chapterMaint.FailList.Changed=function()
	local list={}
	for k=1,chapterMaint.FailList:GetItemCount() do
		local item=chapterMaint.FailList:GetItem(k)
		if item:IsChecked() then
			table.insert(list,item.ID)
		end
	end
	if #list>0 then
		authorStory.Chapters[chapterMaint.ChapterID].FailCondition=list
	else
		authorStory.Chapters[chapterMaint.ChapterID].FailCondition=nil
	end
	authorWindow.SetChangedState(true)
end

chapterMaint.Message=Turbine.UI.Label()
chapterMaint.Message:SetParent(chapterMaint)
chapterMaint.Message:SetSize(chapterMaint:GetWidth()-50,20)
chapterMaint.Message:SetPosition(25,chapterMaint:GetHeight()-25)
chapterMaint.Message:SetFont(Settings.Font)

chapterMaint.MouseMask=Turbine.UI.Control()
chapterMaint.MouseMask:SetParent(chapterMaint)
chapterMaint.MouseMask:SetSize(chapterMaint:GetWidth(),chapterMaint:GetHeight())
chapterMaint.MouseMask:SetMouseVisible(false)
chapterMaint.MouseMask.MouseMove=function()
	if effectSelect:IsVisible() then
		SettingQueueCallback(chapterMaint.HideEffectSelect)
	end
end
chapterMaint.HideEffectSelect=function()
	chapterMaint.MouseMask:SetMouseVisible(false)
	effectSelect:SetVisible(false)
end

chapterMaint.ChapterChanged=false
chapterMaint.SetImage=function(control)
	local tmpImage=Turbine.UI.Control() -- use a temp image to get size since using SetStretchMode causes image to draw outside it's owner even after set back to 0
	-- generate an image
	local tmpFilePath=control.ImagePath
	if tmpFilePath~="" then
		if string.sub(tmpFilePath,-1)~="/" then
			tmpFilePath=tmpFilePath.."/"
		end
	end
	local tmpName=control.FileName
	if tmpFilePath=="" and tonumber(tmpName)~=nil and tonumber(tmpName)>0 then
		tmpFilePath=tonumber(tmpName)
	else
		tmpFilePath=tmpFilePath..tmpName
	end
	local success,result=pcall(Turbine.UI.Control.SetBackground,tmpImage,tmpFilePath)
	if success then
		control.File=tmpFilePath
		control:SetVisible(true)
		tmpImage:SetStretchMode(2)
		control.Width,control.Height=tmpImage:GetSize()
		if control.Width>chapterMaint.Content:GetWidth() then
			-- image is too big, show icon
			control:SetBackground(resourcePath.."ImageIcon.tga")
			control:SetSize(32,32)
			control:GetParent():SetHeight(32)
		else
			control:SetBackground(tmpFilePath)
			control:SetSize(control.Width,control.Height)
			control:GetParent():SetHeight(control.Height)
		end
	else
		control.File=resourcePath.."ImageError.tga"
		control:SetBackground(resourcePath.."ImageError.tga")
		control:SetSize(32,32)
		control.Width=32
		control.Height=32
	end
	control:GetParent():SetHeight(control:GetHeight())
	control:SetLeft((chapterMaint.Content:GetWidth()-control:GetWidth())/2)
end
chapterMaint.SetChapter=function(chapterID)
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	fontMetric:SetFont(Settings.Font)
	chapterMaint.ChapterID=chapterID
	if authorWindow.CurrLanguage:GetValue()==2 then
		chapterMaint.ChapterName:SetText(authorStory.Chapters[chapterID].NameFR)
	elseif authorWindow.CurrLanguage:GetValue()==3 then
		chapterMaint.ChapterName:SetText(authorStory.Chapters[chapterID].NameDE)
	else
		chapterMaint.ChapterName:SetText(authorStory.Chapters[chapterID].Name)
	end
	chapterMaint.Content:ClearItems()
	for k,v in ipairs(authorStory.Chapters[chapterID].Content) do
		local newHeight=controlHeight
		local newWidth=chapterMaint.Content:GetWidth()
		local item
		if v.Type=="Text" then
			item=Turbine.UI.TextBox()
			item:SetSelectable(true)
			item:SetForeColor(Settings.FontColor) -- doesn't take effect for multiline textboxes until AFTER box is actually displayed due to bug in textbox controls (see queued call to RefreshColor below)
			item:SetFont(Settings.Font)
			item:SetMultiline(true)
			if v.Text~=nil then
				if authorWindow.CurrLanguage:GetValue()==2 then
					item:SetText(v.TextFR)
				elseif authorWindow.CurrLanguage:GetValue()==3 then
					item:SetText(v.TextDE)
				else
					item:SetText(v.Text)
				end
				newHeight=fontMetric:GetTextHeight(v.Text,newWidth)
			else
				item:SetText("")
			end
			item.TextChanged=function(sender,args)
				local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
				fontMetric:SetFont(Settings.Font)
				local height=fontMetric:GetTextHeight(sender:GetText(),sender:GetWidth())
				if height<controlHeight then height=controlHeight end
				sender:SetHeight(height)
				authorWindow.SetChangedState(true)
			end
			item.FocusGained=function(sender,args)
				chapterMaint.Content:SetSelectedIndex(sender.Index)
			end
			item.FocusLost=function(sender,args)
				local content=authorStory.Chapters[chapterMaint.ChapterID].Content[sender.Index]
				if content~=nil then
					if authorWindow.CurrLanguage:GetValue()==2 then
						content.TextFR=sender:GetText()
					elseif authorWindow.CurrLanguage:GetValue()==3 then
						content.TextDE=sender:GetText()
					else
						content.Text=sender:GetText()
					end
				end
			end

			item.KeyDown=function(sender,args)
				if args.Action==75 then
					item:TextChanged()
				end
			end
		elseif v.Type=="Image" then
			item=Turbine.UI.Control()
			item:SetWidth(newWidth)
			item.Image=Turbine.UI.Control()
			item.Image:SetParent(item)
			item.Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			item.Image:SetMouseVisible(false)
			item.Image.ImagePath=v.Path
			item.Image.FileName=v.FileName
			if v.Path~=nil and v.FileName~=nil then
				chapterMaint.SetImage(item.Image)
				if item.Image.Width>newWidth then
					newHeight=32
				else
					newHeight=item.Image.Height
				end
			else
				item.Image.File=resourcePath.."ImageError.tga"
				item.Image:SetBackground(resourcePath.."ImageError.tga")
				item.Image:SetSize(32,32)
				item.Image.Width=32
				item.Image.Height=32
				newHeight=32
				item.Image:SetLeft((newWidth-item.Image:GetWidth())/2)
			end
			item.MouseDoubleClick=function(sender,args)
				chapterMaint.MouseMask:SetMouseVisible(true)
				imageMaint.ShowMaint(sender.Image)
			end
		end
		item.MouseDown=function(sender,args)
			chapterMaint.Content:SetSelectedItem(sender)
		end
		item.MouseClick=function(sender,args)
			if args.Button==2 then
				local x,y=Turbine.UI.Display:GetMousePosition()
				chapterMaint.ContentMenu:ShowMenuAt(x+2,y+15)
			end
		end
		item.Index=k
		item:SetParent(chapterMaint.Content)
		item.Type=v.Type

		if authorWindow.CurrLanguage:GetValue()==2 then
			item.Text=v.TextFR
		elseif authorWindow.CurrLanguage:GetValue()==3 then
			item.Text=v.TextDE
		else
			item.Text=v.Text
		end
		item.FileName=v.FileName
		item.Path=v.Path
		item:SetSize(newWidth,newHeight)
--		item:SetMouseVisible(false) -- not sure on this...
		chapterMaint.Content:AddItem(item)
	end
	chapterMaint.Message:SetText("")
	chapterMaint.FillObjectiveList()
	chapterMaint.ObjectiveSetEnabled(false)
	chapterMaint.ObjectiveDelete:SetEnabled(false)
	chapterMaint.ObjectiveOrderUp:SetEnabled(false)
	chapterMaint.ObjectiveOrderDown:SetEnabled(false)
	chapterMaint.LoadTransitions()
	chapterMaint.ObjectiveType:SetSelectedIndex(1)
	chapterMaint.ObjectiveNextChapter:SetSelectedIndex(1)
	chapterMaint.ObjectiveName:SetText("")
	chapterMaint.ObjectiveText:SetText("")
	chapterMaint.ObjectiveRequiredCount:SetText("")
	chapterMaint.ObjectiveString:SetText("")
	chapterMaint.ChapterChanged=false
	SettingQueueCallback(chapterMaint.RefreshColor) -- cheap way to get around bug in multiline textboxes in a list box control
end

authorLoadObjChapterList()
chapterMaint.FillObjectiveList=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	chapterMaint.ObjectiveList:ClearItems()
	chapterMaint.SuccessList:ClearItems()
	chapterMaint.FailList:ClearItems()
	local tmpTable={}
	for k,v in ipairs(authorStory.Chapters[chapterMaint.ChapterID].Objectives) do
		-- add name,ID and display order to tmptable
		table.insert(tmpTable,{["ID"]=k,["Name"]=v.Name,["DisplayOrder"]=v.DisplayOrder})
	end
	if #tmpTable>0 then
		table.sort(tmpTable,function(arg1,arg2) if arg1.DisplayOrder<arg2.DisplayOrder then return true end end)
		for k,v in ipairs(tmpTable) do
			local tmpItem=Turbine.UI.Label()
			tmpItem:SetParent(chapterMaint.ObjectiveList)
			tmpItem.ID=v.ID
			tmpItem:SetSize(chapterMaint.ObjectiveList:GetWidth(),controlHeight)
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetForeColor(Settings.FontColor)
			tmpItem:SetText(v.Name)
			chapterMaint.ObjectiveList:AddItem(tmpItem)

			tmpItem=Turbine.UI.Lotro.CheckBox()
			tmpItem:SetParent(chapterMaint.SuccessList)
			tmpItem.ID=v.ID
			tmpItem:SetSize(chapterMaint.SuccessList:GetWidth(),controlHeight)
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetForeColor(Settings.FontColor)
			tmpItem:SetText(v.Name)
			tmpItem.CheckedChanged=function()
				chapterMaint.SuccessList.Changed()
			end
			chapterMaint.SuccessList:AddItem(tmpItem)

			tmpItem=Turbine.UI.Lotro.CheckBox()
			tmpItem:SetParent(chapterMaint.FailList)
			tmpItem.ID=v.ID
			tmpItem:SetSize(chapterMaint.FailList:GetWidth(),controlHeight)
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetForeColor(Settings.FontColor)
			tmpItem:SetText(v.Name)
			tmpItem.CheckedChanged=function()
				chapterMaint.FailList.Changed()
			end
			chapterMaint.FailList:AddItem(tmpItem)
		end
	else
		chapterMaint.ObjectiveSetEnabled(false)
		chapterMaint.ObjectiveDelete:SetEnabled(false)
		chapterMaint.ObjectiveOrderUp:SetEnabled(false)
		chapterMaint.ObjectiveOrderDown:SetEnabled(false)
	end
end
chapterMaint.LoadTransitions=function()
	-- set the transition listboxes from authorStory
	local chapter=authorStory.Chapters[chapterMaint.ChapterID]
	local index=1
	if chapter.SuccessNextChapter~=nil then
		for k=1,chapterMaint.SuccessNextChapter.ListData:GetItemCount() do
			if chapterMaint.SuccessNextChapter.ListData:GetItem(k).DataValue==chapter.SuccessNextChapter then
				index=k
				break
			end
		end
	end
	chapterMaint.SuccessNextChapter:SetSelectedIndex(index)
	index=1

	if chapter.FailNextChapter~=nil then
		for k=1,chapterMaint.FailNextChapter.ListData:GetItemCount() do
			if chapterMaint.FailNextChapter.ListData:GetItem(k).DataValue==chapter.FailNextChapter then
				index=k
				break
			end
		end
	end
	chapterMaint.FailNextChapter:SetSelectedIndex(index)
	if chapter.SuccessCondition~=nil then
		for index,objective in ipairs(chapter.SuccessCondition) do
			for k=1,chapterMaint.SuccessList:GetItemCount() do
				if chapterMaint.SuccessList:GetItem(k).ID==objective then
					chapterMaint.SuccessList:GetItem(k):SetChecked(true)
					break
				end
			end
		end
	end
	if chapter.FailCondition~=nil then
		for index,objective in ipairs(chapter.FailCondition) do
			for k=1,chapterMaint.FailList:GetItemCount() do
				if chapterMaint.FailList:GetItem(k).ID==objective then
					chapterMaint.FailList:GetItem(k):SetChecked(true)
					break
				end
			end
		end
	end
end
chapterMaint.Closed=function()
	authorWindow.MouseMask:SetMouseVisible(false) -- note, MouseMask is used to simulate modal dialogs
	Storyboard.MouseMask:SetMouseVisible(false)
end
chapterMaint.RefreshLayout=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

--	fontMetric:SetFont(buttonFont)

	fontMetric:SetFont(Settings.Font)
	local min=120
	local tmp=fontMetric:GetTextWidth(Resource[language][45]..":")
	if tmp>min then min=tmp end
	chapterMaint.ChapterLabel:SetSize(min,controlHeight)
	chapterMaint.ChapterLabel:SetFont(Settings.Font)
	chapterMaint.ChapterLabel:SetText(Resource[language][45]..":")
	chapterMaint.ChapterName:SetLeft(chapterMaint.ChapterLabel:GetLeft()+chapterMaint.ChapterLabel:GetWidth()+5)
	chapterMaint.ChapterName:SetSize(chapterMaint:GetWidth()-chapterMaint.ChapterLabel:GetLeft()-chapterMaint.ChapterName:GetLeft()-5,controlHeight)
	chapterMaint.ChapterName:SetFont(Settings.Font)
	chapterMaint.ChapterName:SetText(chapterMaint.ChapterName:GetText())

	min=fontMetric:GetTextWidth(Resource[language][189])
	chapterMaint.InfoTab.Underscore:SetWidth(min)
	min=min+20
	tmp=fontMetric:GetTextWidth(Resource[language][42])
	chapterMaint.ObjectiveTab.Underscore:SetWidth(tmp)
	if tmp+20>min then min=tmp+20 end
	tmp=fontMetric:GetTextWidth(Resource[language][43])
	chapterMaint.TransitionTab.Underscore:SetWidth(tmp)
	if tmp+20>min then min=tmp+20 end

	chapterMaint.Message:SetHeight(controlHeight)
	chapterMaint.Message:SetTop(chapterMaint:GetHeight()-chapterMaint.Message:GetHeight()-5)
	chapterMaint.Message:SetFont(Settings.Font)
	chapterMaint.Message:SetText(chapterMaint.Message:GetText())

	chapterMaint.InfoTab:SetSize(min,controlHeight)
	chapterMaint.InfoTab:SetTop(chapterMaint.ChapterLabel:GetTop()+chapterMaint.ChapterLabel:GetHeight()+10)
	chapterMaint.InfoTab:SetFont(Settings.Font)
	chapterMaint.InfoTab:SetText(Resource[language][189])
	chapterMaint.InfoTab.Underscore:SetTop(chapterMaint.InfoTab:GetHeight()-1)

	chapterMaint.ObjectiveTab:SetSize(min,controlHeight)
	chapterMaint.ObjectiveTab:SetPosition(chapterMaint.InfoTab:GetLeft()+min+5,chapterMaint.InfoTab:GetTop())
	chapterMaint.ObjectiveTab:SetFont(Settings.Font)
	chapterMaint.ObjectiveTab:SetText(Resource[language][42])
	chapterMaint.ObjectiveTab.Underscore:SetTop(chapterMaint.ObjectiveTab:GetHeight()-1)

	chapterMaint.TransitionTab:SetSize(min,controlHeight)
	chapterMaint.TransitionTab:SetPosition(chapterMaint.ObjectiveTab:GetLeft()+min+5,chapterMaint.InfoTab:GetTop())
	chapterMaint.TransitionTab:SetFont(Settings.Font)
	chapterMaint.TransitionTab:SetText(Resource[language][43])
	chapterMaint.TransitionTab.Underscore:SetTop(chapterMaint.TransitionTab:GetHeight()-1)

	chapterMaint.InfoPanel:SetPosition(10,chapterMaint.InfoTab:GetTop()+chapterMaint.InfoTab:GetHeight()+5)
	chapterMaint.InfoPanel:SetSize(chapterMaint:GetWidth()-chapterMaint.InfoPanel:GetLeft()*2,chapterMaint:GetHeight()-chapterMaint.InfoPanel:GetTop()-chapterMaint.Message:GetHeight()-5)
	chapterMaint.ObjectivePanel:SetSize(chapterMaint.InfoPanel:GetSize())
	chapterMaint.ObjectivePanel:SetPosition(chapterMaint.InfoPanel:GetPosition())
	chapterMaint.TransitionPanel:SetSize(chapterMaint.InfoPanel:GetSize())
	chapterMaint.TransitionPanel:SetPosition(chapterMaint.InfoPanel:GetPosition())

	chapterMaint.ContentCaption:SetSize(fontMetric:GetTextWidth(Resource[language][44]),controlHeight)
	chapterMaint.ContentCaption:SetFont(Settings.Font)
	chapterMaint.ContentCaption:SetText(Resource[language][44])
	chapterMaint.ContentBack:SetTop(chapterMaint.ContentCaption:GetTop()+chapterMaint.ContentCaption:GetHeight()+5)
	chapterMaint.ContentBack:SetSize(chapterMaint.InfoPanel:GetWidth()-10,chapterMaint.InfoPanel:GetHeight()-chapterMaint.ContentBack:GetTop())
	local contentWidth=chapterMaint.ContentBack:GetWidth()-2
	chapterMaint.Content:SetSize(contentWidth,chapterMaint.ContentBack:GetHeight()-2)
	for k=1,chapterMaint.Content:GetItemCount() do
		local tmpItem=chapterMaint.Content:GetItem(k)
		if tmpItem.Type=="Text" then
			tmpItem:SetSize(contentWidth,fontMetric:GetTextHeight(tmpItem:GetText(),contentWidth))
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetText(tmpItem:GetText())
		elseif tmpItem.Type=="Image" then
			tmpItem:SetWidth(contentWidth)
			if contentWidth>=tmpItem.Image.Width then
				tmpItem.Image:SetBackground(tmpItem.Image.File)
				tmpItem.Image:SetSize(tmpItem.Image.Width,tmpItem.Image.Height)
				tmpItem:SetHeight(tmpItem.Image.Height)
			else
				tmpItem.Image:SetBackground(resourcePath.."ImageIcon.tga")
				tmpItem.Image:SetSize(32,32)
				tmpItem:SetHeight(32)
			end
			tmpItem.Image:SetLeft((contentWidth-tmpItem.Image:GetWidth())/2)
		end
	end
	chapterMaint.ContentVScroll:SetHeight(chapterMaint.ContentBack:GetHeight())
	chapterMaint.ContentVScroll:SetPosition(chapterMaint.ContentBack:GetLeft()+chapterMaint.ContentBack:GetWidth(),chapterMaint.ContentBack:GetTop())

	fontMetric:SetFont(buttonFont)
	local minObjButton=fontMetric:GetTextWidth(Resource[language][26])+20
	tmp=fontMetric:GetTextWidth(Resource[language][102])+20
	if tmp>minObjButton then minObjButton=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][11])+20
	if tmp>minObjButton then minObjButton=tmp end

	fontMetric:SetFont(Settings.Font)
	local minObjLabel=fontMetric:GetTextWidth(Resource[language][90]..":")+20
	tmp=fontMetric:GetTextWidth(Resource[language][91]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][92]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][93]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][94]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][101]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][103]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][104]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][125]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][126]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][127]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][128]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][129]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][131]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][202]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][203]..":")+20
	if tmp>minObjLabel then minObjLabel=tmp end

--	local goToWidth=0
--	for k,v in ipairs(authorStory.Chapters) do
--		tmp=fontMetric:GetTextWidth(v.Name)+20
--		if tmp>goToWidth then goToWidth=tmp end
--	end
--	local tranGoToWidth=goToWidth
--	tmp=fontMetric:GetTextWidth(Resource[language][109]..":")+20
--	if tmp>tranGoToWidth then tranGoToWidth=tmp end
--	tmp=fontMetric:GetTextWidth(Resource[language][97]..":")+20
--	if tmp>tranGoToWidth then tranGoToWidth=tmp end
--
--	tmp=fontMetric:GetTextWidth(Resource[language][100]..":")+20
--	if tmp>goToWidth then goToWidth=tmp end
--	tmp=fontMetric:GetTextWidth(Resource[language][97]..":")+20
--	if tmp>goToWidth then goToWidth=tmp end

	chapterMaint.ObjectiveListCaption:SetHeight(controlHeight)
	chapterMaint.ObjectiveListCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveListCaption:SetText(Resource[language][89])

	chapterMaint.ObjectiveListBorder:SetTop(chapterMaint.ObjectiveListCaption:GetTop()+chapterMaint.ObjectiveListCaption:GetHeight()+5)
	chapterMaint.ObjectiveListBorder:SetHeight(chapterMaint.ObjectivePanel:GetHeight()-chapterMaint.ObjectiveListBorder:GetTop())
	chapterMaint.ObjectiveList:SetHeight(chapterMaint.ObjectiveListBorder:GetHeight()-2)

	chapterMaint.ObjectiveList:SetHeight(chapterMaint.ObjectiveListBorder:GetHeight()-2)
	chapterMaint.ObjectiveListVScroll:SetTop(chapterMaint.ObjectiveList:GetTop())
	chapterMaint.ObjectiveListVScroll:SetHeight(chapterMaint.ObjectiveList:GetHeight())

	chapterMaint.ObjectiveNew:SetPosition(chapterMaint.ObjectiveListCaption:GetLeft()+chapterMaint.ObjectiveListCaption:GetWidth()+15,chapterMaint.ObjectiveListCaption:GetTop())
	chapterMaint.ObjectiveNew:SetFont(buttonFont)
	chapterMaint.ObjectiveNew:SetWidth(minObjButton)
	chapterMaint.ObjectiveNew:SetText(Resource[language][26])
	chapterMaint.ObjectiveDelete:SetPosition(chapterMaint.ObjectiveNew:GetLeft()+chapterMaint.ObjectiveNew:GetWidth()+5,chapterMaint.ObjectiveNew:GetTop())
	chapterMaint.ObjectiveDelete:SetFont(buttonFont)
	chapterMaint.ObjectiveDelete:SetWidth(minObjButton)
	chapterMaint.ObjectiveDelete:SetText(Resource[language][11])
	chapterMaint.ObjectiveTypeCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveTypeCaption:SetPosition(chapterMaint.ObjectiveNew:GetLeft(),chapterMaint.ObjectiveNew:GetTop()+chapterMaint.ObjectiveNew:GetHeight()+5)
	chapterMaint.ObjectiveTypeCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveTypeCaption:SetText(Resource[language][90]..":")
	chapterMaint.ObjectiveType:SetPosition(chapterMaint.ObjectiveTypeCaption:GetLeft()+chapterMaint.ObjectiveTypeCaption:GetWidth()+5,chapterMaint.ObjectiveTypeCaption:GetTop())
	chapterMaint.ObjectiveType:SetSize(chapterMaint.ObjectivePanel:GetWidth()-chapterMaint.ObjectiveType:GetLeft(),controlHeight)
	chapterMaint.ObjectiveType:SetFont(Settings.Font)

	chapterMaint.ObjectiveNextChapterCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveNextChapterCaption:SetPosition(chapterMaint.ObjectiveTypeCaption:GetLeft(),chapterMaint.ObjectiveTypeCaption:GetTop()+chapterMaint.ObjectiveTypeCaption:GetHeight()+5)
	chapterMaint.ObjectiveNextChapterCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveNextChapterCaption:SetText(Resource[language][93]..":")
	chapterMaint.ObjectiveNextChapter:SetPosition(chapterMaint.ObjectiveNextChapterCaption:GetLeft()+chapterMaint.ObjectiveNextChapterCaption:GetWidth()+5,chapterMaint.ObjectiveNextChapterCaption:GetTop())
--	if goToWidth>chapterMaint.ObjectivePanel:GetWidth()-chapterMaint.ObjectiveNextChapter:GetLeft() then goToWidth=chapterMaint.ObjectivePanel:GetWidth()-chapterMaint.ObjectiveNextChapter:GetLeft() end
	chapterMaint.ObjectiveNextChapter:SetSize(chapterMaint.ObjectivePanel:GetWidth()-chapterMaint.ObjectiveNextChapter:GetLeft(),controlHeight)
	chapterMaint.ObjectiveNextChapter:SetFont(Settings.Font)

	chapterMaint.ObjectiveNameCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveNameCaption:SetPosition(chapterMaint.ObjectiveNextChapterCaption:GetLeft(),chapterMaint.ObjectiveNextChapterCaption:GetTop()+chapterMaint.ObjectiveNextChapterCaption:GetHeight()+5)
	chapterMaint.ObjectiveNameCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveNameCaption:SetText(Resource[language][91]..":")
	chapterMaint.ObjectiveName:SetPosition(chapterMaint.ObjectiveType:GetLeft(),chapterMaint.ObjectiveNameCaption:GetTop())
	chapterMaint.ObjectiveName:SetSize(chapterMaint.ObjectiveType:GetSize())
	chapterMaint.ObjectiveName:SetFont(Settings.Font)
	chapterMaint.ObjectiveName:SetText(chapterMaint.ObjectiveName:GetText())

	chapterMaint.ObjectiveRequiredCountCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveRequiredCountCaption:SetPosition(chapterMaint.ObjectiveTypeCaption:GetLeft(),chapterMaint.ObjectiveNameCaption:GetTop()+5+controlHeight)
	chapterMaint.ObjectiveRequiredCountCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveRequiredCountCaption:SetText(Resource[language][94]..":")
	chapterMaint.ObjectiveRequiredCount:SetPosition(chapterMaint.ObjectiveType:GetLeft(),chapterMaint.ObjectiveRequiredCountCaption:GetTop())
	chapterMaint.ObjectiveRequiredCount:SetSize(chapterMaint.ObjectiveType:GetSize())
	chapterMaint.ObjectiveRequiredCount:SetFont(Settings.Font)
	chapterMaint.ObjectiveRequiredCount:SetText(chapterMaint.ObjectiveRequiredCount:GetText())

	chapterMaint.ObjectiveChatList:SetPosition(chapterMaint.ObjectiveRequiredCount:GetPosition())
	chapterMaint.ObjectiveChatList:SetSize(chapterMaint.ObjectiveRequiredCount:GetSize())
	chapterMaint.ObjectiveChatList:SetFont(Settings.Font)

	chapterMaint.ObjectiveRegionList:SetPosition(chapterMaint.ObjectiveRequiredCount:GetPosition())
	chapterMaint.ObjectiveRegionList:SetSize(chapterMaint.ObjectiveRequiredCount:GetSize())
	chapterMaint.ObjectiveRegionList:SetFont(Settings.Font)

	chapterMaint.ObjectiveStringCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveStringCaption:SetPosition(chapterMaint.ObjectiveTypeCaption:GetLeft(),chapterMaint.ObjectiveRequiredCountCaption:GetTop()+5+controlHeight)
	chapterMaint.ObjectiveStringCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveStringCaption:SetText(chapterMaint.ObjectiveStringCaption:GetText())
	chapterMaint.ObjectiveString:SetPosition(chapterMaint.ObjectiveType:GetLeft(),chapterMaint.ObjectiveStringCaption:GetTop())
	chapterMaint.ObjectiveString:SetSize(chapterMaint.ObjectiveType:GetWidth()-12,controlHeight)
	chapterMaint.ObjectiveString:SetFont(Settings.Font)
	chapterMaint.ObjectiveString:SetText(chapterMaint.ObjectiveString:GetText())

	chapterMaint.CaptureTarget:SetPosition(chapterMaint.ObjectiveString:GetLeft()+chapterMaint.ObjectiveString:GetWidth(),chapterMaint.ObjectiveString:GetTop()+(controlHeight-12)/2)
	chapterMaint.CaptureLocation:SetPosition(chapterMaint.ObjectiveString:GetLeft()+chapterMaint.ObjectiveString:GetWidth(),chapterMaint.ObjectiveString:GetTop()+(controlHeight-12)/2)
	chapterMaint.CaptureEffect:SetPosition(chapterMaint.ObjectiveString:GetLeft()+chapterMaint.ObjectiveString:GetWidth(),chapterMaint.ObjectiveString:GetTop()+(controlHeight-12)/2)

	-- these controls are placed relative to the bottom in reverse order
	chapterMaint.ObjectiveDisplayOrderCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveDisplayOrderCaption:SetPosition(chapterMaint.ObjectiveTypeCaption:GetLeft(),chapterMaint.ObjectivePanel:GetHeight()-5-controlHeight)
	chapterMaint.ObjectiveDisplayOrderCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveDisplayOrderCaption:SetText(Resource[language][101]..":")
	fontMetric:SetFont(buttonFont)
	local minObjDOButtonWidth=fontMetric:GetTextWidth(Resource[language][25])+20
	tmp=fontMetric:GetTextWidth(Resource[language][28])+20
	if tmp>minObjDOButtonWidth then minObjDOButtonWidth=tmp end
	chapterMaint.ObjectiveOrderUp:SetPosition(chapterMaint.ObjectiveType:GetLeft(),chapterMaint.ObjectiveDisplayOrderCaption:GetTop()+(chapterMaint.ObjectiveDisplayOrderCaption:GetHeight()-20)/2)
	chapterMaint.ObjectiveOrderUp:SetWidth(minObjDOButtonWidth)
	chapterMaint.ObjectiveOrderUp:SetFont(buttonFont)
	chapterMaint.ObjectiveOrderUp:SetText(Resource[language][25])
	chapterMaint.ObjectiveOrderDown:SetPosition(chapterMaint.ObjectiveOrderUp:GetLeft()+chapterMaint.ObjectiveOrderUp:GetWidth()+5,chapterMaint.ObjectiveOrderUp:GetTop())
	chapterMaint.ObjectiveOrderDown:SetWidth(minObjDOButtonWidth)
	chapterMaint.ObjectiveOrderDown:SetFont(buttonFont)
	chapterMaint.ObjectiveOrderDown:SetText(Resource[language][28])

	-- now Text takes up the remainder of the panel
	chapterMaint.ObjectiveTextCaption:SetPosition(chapterMaint.ObjectiveTypeCaption:GetLeft(),chapterMaint.ObjectiveStringCaption:GetTop()+chapterMaint.ObjectiveStringCaption:GetHeight()+5)
	chapterMaint.ObjectiveTextCaption:SetSize(minObjLabel,controlHeight)
	chapterMaint.ObjectiveTextCaption:SetFont(Settings.Font)
	chapterMaint.ObjectiveTextCaption:SetText(Resource[language][92]..":")
	chapterMaint.ObjectiveTextBorder:SetPosition(chapterMaint.ObjectiveType:GetLeft(),chapterMaint.ObjectiveTextCaption:GetTop())
	chapterMaint.ObjectiveTextBorder:SetSize(chapterMaint.ObjectiveType:GetWidth()-10,chapterMaint.ObjectiveDisplayOrderCaption:GetTop()-chapterMaint.ObjectiveTextCaption:GetTop()-5)
	chapterMaint.ObjectiveText:SetSize(chapterMaint.ObjectiveTextBorder:GetWidth()-2,chapterMaint.ObjectiveTextBorder:GetHeight()-2)
	chapterMaint.ObjectiveText:SetFont(Settings.Font)
	chapterMaint.ObjectiveText:SetText(chapterMaint.ObjectiveText:GetText())
	chapterMaint.ObjectiveTextVScroll:SetPosition(chapterMaint.ObjectiveTextBorder:GetLeft()+chapterMaint.ObjectiveTextBorder:GetWidth(),chapterMaint.ObjectiveTextBorder:GetTop())
	chapterMaint.ObjectiveTextVScroll:SetHeight(chapterMaint.ObjectiveTextBorder:GetHeight())

	chapterMaint.SuccessNextCaption:SetFont(Settings.Font)
	chapterMaint.SuccessNextCaption:SetText(Resource[language][107])
	chapterMaint.SuccessNextCaption:SetSize(chapterMaint.TransitionPanel:GetWidth()/2-5,controlHeight)
	chapterMaint.SuccessNextCaption:SetPosition(0,0)

	chapterMaint.SuccessNextChapter:SetSize(chapterMaint.SuccessCaption:GetWidth(),controlHeight)
	chapterMaint.SuccessNextChapter:SetFont(Settings.Font)
--	if tranGoToWidth>chapterMaint.SuccessNextCaption:GetWidth() then tranGoToWidth=chapterMaint.SuccessNextCaption:GetWidth() end
	chapterMaint.SuccessNextChapter:SetWidth(chapterMaint.SuccessNextCaption:GetWidth())
	chapterMaint.SuccessNextChapter:SetPosition(0,chapterMaint.SuccessNextCaption:GetTop()+chapterMaint.SuccessNextCaption:GetHeight()+5)

	chapterMaint.SuccessCaption:SetPosition(0,chapterMaint.SuccessNextChapter:GetTop()+chapterMaint.SuccessNextChapter:GetHeight()+5)
	chapterMaint.SuccessCaption:SetSize(chapterMaint.TransitionPanel:GetWidth()/2-5,controlHeight)
	chapterMaint.SuccessCaption:SetFont(Settings.Font)
	chapterMaint.SuccessCaption:SetText(Resource[language][105])

	chapterMaint.SuccessBorder:SetPosition(0,chapterMaint.SuccessCaption:GetTop()+chapterMaint.SuccessCaption:GetHeight()+5)
	chapterMaint.SuccessBorder:SetSize(chapterMaint.TransitionPanel:GetWidth()/2-15,chapterMaint.TransitionPanel:GetHeight()-chapterMaint.SuccessBorder:GetTop())
	chapterMaint.SuccessList:SetSize(chapterMaint.SuccessBorder:GetWidth()-2,chapterMaint.SuccessBorder:GetHeight()-2)
	chapterMaint.SuccessVScroll:SetPosition(chapterMaint.SuccessBorder:GetLeft()+chapterMaint.SuccessBorder:GetWidth(),chapterMaint.SuccessBorder:GetTop())
	chapterMaint.SuccessVScroll:GetHeight(chapterMaint.SuccessBorder:GetHeight())

	local failLeft=chapterMaint.TransitionPanel:GetWidth()/2
	chapterMaint.FailCaption:SetPosition(failLeft,chapterMaint.SuccessCaption:GetTop())
	chapterMaint.FailCaption:SetSize(chapterMaint.SuccessCaption:GetSize())
	chapterMaint.FailCaption:SetFont(Settings.Font)
	chapterMaint.FailCaption:SetText(Resource[language][106])

	chapterMaint.FailNextChapter:SetSize(chapterMaint.SuccessNextChapter:GetSize())
	chapterMaint.FailNextChapter:SetFont(Settings.Font)
	chapterMaint.FailNextChapter:SetWidth(chapterMaint.SuccessCaption:GetWidth())
	chapterMaint.FailNextChapter:SetPosition(failLeft,chapterMaint.SuccessNextChapter:GetTop())

	chapterMaint.FailNextCaption:SetFont(Settings.Font)
	chapterMaint.FailNextCaption:SetText(Resource[language][108])
	chapterMaint.FailNextCaption:SetSize(chapterMaint.SuccessNextCaption:GetSize())
	chapterMaint.FailNextCaption:SetPosition(failLeft,chapterMaint.SuccessNextCaption:GetTop())

	chapterMaint.FailBorder:SetPosition(failLeft,chapterMaint.SuccessBorder:GetTop())
	chapterMaint.FailBorder:SetSize(chapterMaint.SuccessBorder:GetSize())
	chapterMaint.FailList:SetSize(chapterMaint.SuccessList:GetSize())
	chapterMaint.FailVScroll:SetPosition(chapterMaint.FailBorder:GetLeft()+chapterMaint.FailBorder:GetWidth(),chapterMaint.FailBorder:GetTop())
	chapterMaint.FailVScroll:GetHeight(chapterMaint.SuccessVScroll:GetHeight())

	chapterMaint.MouseMask:SetSize(chapterMaint:GetWidth(),chapterMaint:GetHeight())
	effectSelect:SetPosition(chapterMaint.ObjectivePanel:GetLeft()+chapterMaint.ObjectivePanel:GetWidth()-effectSelect:GetWidth(),chapterMaint.ObjectivePanel:GetTop())
	effectSelect:SetHeight(chapterMaint.ObjectivePanel:GetHeight())
	effectSelect.Caption:SetSize(effectSelect:GetWidth()-2,controlHeight)
	effectSelect.Caption:SetPosition(1,1)
	effectSelect.Caption:SetFont(Settings.Font)
	effectSelect.Caption:SetText(Resource[language][233])
	effectSelect.EffectList:SetPosition(1,effectSelect.Caption:GetTop()+effectSelect.Caption:GetHeight()+1)
	effectSelect.EffectList:SetSize(effectSelect:GetWidth()-12,effectSelect:GetHeight()-effectSelect.EffectList:GetTop()-1)
	effectSelect.VScroll:SetPosition(effectSelect.EffectList:GetLeft()+effectSelect.EffectList:GetWidth(),effectSelect.EffectList:GetTop())
	effectSelect.VScroll:SetHeight(effectSelect.EffectList:GetHeight())
end
chapterMaint.RefreshLayout()
chapterMaint.SizeChanged=function()
	Settings.ChapterMaintWidth=chapterMaint:GetWidth()/displayWidth
	Settings.ChapterMaintHeight=chapterMaint:GetHeight()/displayWidth
	chapterMaint.RefreshLayout()
end
chapterMaint.RefreshColor=function()
	chapterMaint.ChapterLabel:SetForeColor(Settings.LabelColor)
	chapterMaint.ChapterName:SetForeColor(Settings.FontColor)

	chapterMaint.InfoTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.ObjectiveTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.TransitionTab:SetForeColor(Settings.TabUnSelectedColor)
	chapterMaint.InfoTab.Underscore:SetBackColor(Settings.TabSelectedColor)
	chapterMaint.ObjectiveTab.Underscore:SetBackColor(Settings.TabSelectedColor)
	chapterMaint.TransitionTab.Underscore:SetBackColor(Settings.TabSelectedColor)
	if chapterMaint.InfoTab.Selected then
		chapterMaint.InfoTab:SetForeColor(Settings.TabSelectedColor)
	elseif chapterMaint.ObjectiveTab.Selected then
		chapterMaint.ObjectiveTab:SetForeColor(Settings.TabSelectedColor)
	else
		chapterMaint.TransitionTab:SetForeColor(Settings.TabSelectedColor)
	end
	chapterMaint.ContentCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ContentBack:SetBackColor(Settings.TrimColor)
	chapterMaint.Content:SetBackColor(Settings.BackColor)
	for k=1,chapterMaint.Content:GetItemCount() do
		local item=chapterMaint.Content:GetItem(k)
		if item.Type=="Text" then
			chapterMaint.Content:GetItem(k):SetForeColor(Settings.FontColor)
		elseif item.Type=="Image" then
		end
	end
	chapterMaint.ObjectiveListCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveListBorder:SetBackColor(Settings.TrimColor)
	chapterMaint.ObjectiveList:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveTypeCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveType:SetBorderColor(Settings.TrimColor)
	chapterMaint.ObjectiveType:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveType.CurrentValue:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveType:SetTextColor(Settings.FontColor)

	chapterMaint.ObjectiveChatList:SetBorderColor(Settings.TrimColor)
	chapterMaint.ObjectiveChatList:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveChatList.CurrentValue:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveChatList:SetTextColor(Settings.FontColor)

	chapterMaint.ObjectiveRegionList:SetBorderColor(Settings.TrimColor)
	chapterMaint.ObjectiveRegionList:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveRegionList.CurrentValue:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveRegionList:SetTextColor(Settings.FontColor)

	chapterMaint.ObjectiveNextChapterCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveNextChapter:SetBorderColor(Settings.TrimColor)
	chapterMaint.ObjectiveNextChapter:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveNextChapter.CurrentValue:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveNextChapter:SetTextColor(Settings.FontColor)

	chapterMaint.ObjectiveNameCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveName:SetForeColor(Settings.FontColor)

	chapterMaint.ObjectiveTextCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveTextBorder:SetBackColor(Settings.TrimColor)
	chapterMaint.ObjectiveText:SetBackColor(Settings.BackColor)
	chapterMaint.ObjectiveText:SetForeColor(Settings.FontColor)
	chapterMaint.ObjectiveDisplayOrderCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveRequiredCountCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveRequiredCount:SetForeColor(Settings.FontColor)
	chapterMaint.ObjectiveStringCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.ObjectiveString:SetForeColor(Settings.FontColor)

	chapterMaint.SuccessCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.SuccessBorder:SetBackColor(Settings.TrimColor)
	chapterMaint.SuccessList:SetBackColor(Settings.BackColor)
	chapterMaint.SuccessNextCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.SuccessNextChapter:SetBorderColor(Settings.TrimColor)
	chapterMaint.SuccessNextChapter:SetBackColor(Settings.BackColor)
	chapterMaint.SuccessNextChapter.CurrentValue:SetBackColor(Settings.BackColor)
	chapterMaint.SuccessNextChapter:SetTextColor(Settings.FontColor)

	chapterMaint.FailCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.FailBorder:SetBackColor(Settings.TrimColor)
	chapterMaint.FailList:SetBackColor(Settings.BackColor)
	chapterMaint.FailNextCaption:SetForeColor(Settings.LabelColor)
	chapterMaint.FailNextChapter:SetBorderColor(Settings.TrimColor)
	chapterMaint.FailNextChapter:SetBackColor(Settings.BackColor)
	chapterMaint.FailNextChapter.CurrentValue:SetBackColor(Settings.BackColor)
	chapterMaint.FailNextChapter:SetTextColor(Settings.FontColor)

end
chapterMaint.RefreshColor()

chapterMaint.chatListener=function(sender, args)
	-- check message for standard channel matching "You are at: r.* lx.* ly.* ox.* oy.* oz.* h.*"
	if args.ChatType==Turbine.ChatType.Standard and chapterMaint.CaptureLocationQS.Enabled then
		local locationString,headingString,patternString1,patternString2,patternString3,patternString4;
		locale=Turbine.Engine:GetLanguage()
		if locale==Turbine.Language.French then
			locationString="Votre emplacement .*: r.*"
			headingString="Votre emplacement .*: r.* h.*"
			patternString1="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
			patternString2="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
			patternString3="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
			patternString4="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		elseif locale==Turbine.Language.German then
			locationString="Ihr befindet Euch hier: r.*"
			headingString="Ihr befindet Euch hier: r.* h.*"
			patternString1="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
			patternString2="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
			patternString3="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
			patternString4="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		else
			-- russian is not currently supported by this plugin
			locationString="You are at: r.*"
			headingString="You are at: r.* h.*"
			patternString1="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
			patternString2="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
			patternString3="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
			patternString4="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		end
		if string.find(args.Message,locationString)~=nil then
			local region, lx, ly, ox, oy, oz, heading;
			if string.find(args.Message,headingString)==nil then
				-- there is a carriage return at the end of the message :(
				heading=0;
				region, lx, ly, ox, oy, oz = string.match(args.Message,patternString1);
				if region==nil then
					--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
					region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2);
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3);
						if region==nil then
							region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4);
						end
					end
				end
			else
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString1.." h(%d+%.?%d*)");
				if region==nil then
					--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
					region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2.." h(%d+%.?%d*)");
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3.." h(%d+%.?%d*)");
						if region==nil then
							region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4.." h(%d+%.?%d*).*");
						end
					end
				end
			end
			if region ~= nil then
				if heading ==nil then
					-- when facing north the heading value is not present
					heading=0
				end
				region=tonumber(region);
				ox=euroNormalize(ox);
				oy=euroNormalize(oy);
				oz=euroNormalize(oz);
				heading=euroNormalize(heading);
				chapterMaint.ObjectiveRegionList:SetSelectedIndex(region)
				chapterMaint.ObjectiveRegionList.SelectedIndexChanged()
				-- now get N/S, E/W (or we could just save the ox,oy values...)
				local ew=math.floor((( math.floor( lx / 8 ) * 160 + ox ) - 29360) / 20 +.5)/10
				local ns=math.floor((( math.floor( ly / 8 ) * 160 + oy ) - 24880) / 20 +.5)/10
				chapterMaint.ObjectiveString:SetText(tostring(ns)..", "..tostring(ew))
				chapterMaint.ObjectiveString.TextChanged()
			end
		end
	end
end
AddCallback(Turbine.Chat, "Received", chapterMaint.chatListener);
