importPath=string.gsub(getfenv(1)._.Name,"%.Reader","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
storyPath=string.gsub(importPath,"%.","/").."Stories/"

showTime=false -- this is just a debugging setting
if showTime then Turbine.Shell.WriteLine("reader start:"..tostring(Turbine.Engine:GetLocalTime())) end
pluginName="Anthology"
import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

getRaceName=function(race)
	local ret
	if race==Turbine.Gameplay.Race.Beorning then
		ret=Resource[language][133]
	elseif race==Turbine.Gameplay.Race.Dwarf then
		ret=Resource[language][134]
	elseif race==Turbine.Gameplay.Race.Elf then
		ret=Resource[language][135]
	elseif race==Turbine.Gameplay.Race.HighElf then
		ret=Resource[language][136]
	elseif race==Turbine.Gameplay.Race.Hobbit then
		ret=Resource[language][137]
	elseif race==Turbine.Gameplay.Race.Man then
		ret=Resource[language][138]
	elseif race==6 then --uruk
		ret=Resource[language][139]
	elseif race==7 then -- orc
		ret=Resource[language][140]
	elseif race==74 then -- Dunedain
		ret=Resource[language][141]
	elseif race==66 then -- warg
		ret=Resource[language][142]
	elseif race==66 then -- spider
		ret=Resource[language][143]
	elseif race==27 then -- chicken
		ret=Resource[language][144]
	else
		-- troll?
		ret=Resource[language][145]
	end
	return ret
end
getClassName=function(class)
	local ret
	if class==Turbine.Gameplay.Class.Beorning then
		ret=Resource[language][133]
	elseif class==Turbine.Gameplay.Class.BlackArrow then
		ret=Resource[language][146]
	elseif class==Turbine.Gameplay.Class.Burglar then
		ret=Resource[language][147]
	elseif class==Turbine.Gameplay.Class.Captain then
		ret=Resource[language][148]
	elseif class==Turbine.Gameplay.Class.Champion then
		ret=Resource[language][149]
	elseif class==Turbine.Gameplay.Class.Chicken then
		ret=Resource[language][144]
	elseif class==Turbine.Gameplay.Class.Defiler then
		ret=Resource[language][150]
	elseif class==Turbine.Gameplay.Class.Guardian then
		ret=Resource[language][151]
	elseif class==Turbine.Gameplay.Class.Hunter then
		ret=Resource[language][152]
	elseif class==Turbine.Gameplay.Class.LoreMaster then
		ret=Resource[language][153]
	elseif class==Turbine.Gameplay.Class.Minstrel then
		ret=Resource[language][154]
	elseif class==Turbine.Gameplay.Class.Ranger then
		ret=Resource[language][155]
	elseif class==Turbine.Gameplay.Class.Reaver then
		ret=Resource[language][156]
	elseif class==Turbine.Gameplay.Class.RuneKeeper then
		ret=Resource[language][157]
	elseif class==Turbine.Gameplay.Class.Stalker then
		ret=Resource[language][158]
	elseif class==Turbine.Gameplay.Class.Troll then
		ret=Resource[language][145]
	elseif class==Turbine.Gameplay.Class.Warden then
		ret=Resource[language][159]
	elseif class==Turbine.Gameplay.Class.WarLeader then
		ret=Resource[language][160]
	elseif class==Turbine.Gameplay.Class.Weaver then
		ret=Resource[language][161]
	else
		ret="professional" -- undefined class
	end
	return ret
end

displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()
localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
localPlayer.Name=localPlayer:GetName()
localPlayer.RaceName=getRaceName(localPlayer:GetRace())
localPlayer.ClassName=getClassName(localPlayer:GetClass())
localPlayer.Backpack=localPlayer:GetBackpack()
localPlayer.Equipment=localPlayer:GetEquipment()
localPlayer.EffectsList=localPlayer:GetEffects()

if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end
if showTime then Turbine.Shell.WriteLine("load Settings:"..tostring(Turbine.Engine:GetLocalTime())) end

-- load saved settings - we need this in Main because this supports the OptionsWindow
Settings=PatchDataLoad(Turbine.DataScope.Account, pluginName.."Settings")
if Settings==nil then Settings={} end
if Settings.DataVersion==nil then
	Settings.DataVersion=plugin:GetVersion()
end
if Settings.MaxID==nil then
	Settings.MaxID=0
end
if Settings.Font==nil then
	Settings.Font=Turbine.UI.Lotro.Font.Verdana18
end
if Settings.FontColor==nil then
	Settings.FontColor=Turbine.UI.Color.White
else
	Settings.FontColor=Turbine.UI.Color(Settings.FontColor.R,Settings.FontColor.G,Settings.FontColor.B)
end
if Settings.BackColor==nil then
	Settings.BackColor=Turbine.UI.Color.Black
else
	Settings.BackColor=Turbine.UI.Color(Settings.BackColor.R,Settings.BackColor.G,Settings.BackColor.B)
end
if Settings.HeadingColor==nil then
	Settings.HeadingColor=Turbine.UI.Color.LightBlue
else
	Settings.HeadingColor=Turbine.UI.Color(Settings.HeadingColor.R,Settings.HeadingColor.G,Settings.HeadingColor.B)
end
if Settings.LabelColor==nil then
	Settings.LabelColor=Turbine.UI.Color(.843,.698,.227)
else
	Settings.LabelColor=Turbine.UI.Color(Settings.LabelColor.R,Settings.LabelColor.G,Settings.LabelColor.B)
end
if Settings.TabSelectedColor==nil then
	Settings.TabSelectedColor=Turbine.UI.Color.LightBlue
else
	Settings.TabSelectedColor=Turbine.UI.Color(Settings.TabSelectedColor.R,Settings.TabSelectedColor.G,Settings.TabSelectedColor.B)
end
if Settings.TabUnSelectedColor==nil then
	Settings.TabUnSelectedColor=Turbine.UI.Color(.2,.25,1)
else
	Settings.TabUnSelectedColor=Turbine.UI.Color(Settings.TabUnSelectedColor.R,Settings.TabUnSelectedColor.G,Settings.TabUnSelectedColor.B)
end

if Settings.TrimColor==nil then
	Settings.TrimColor=Turbine.UI.Color(.15,.15,.25)
else
	Settings.TrimColor=Turbine.UI.Color(Settings.TrimColor.R,Settings.TrimColor.G,Settings.TrimColor.B)
end

if Settings.LanguageEN==nil then
	Settings.LanguageEN=(locale == "en")
end
if Settings.LanguageDE==nil then
	Settings.LanguageDE=(locale == "de")
end
if Settings.LanguageFR==nil then
	Settings.LanguageFR=(locale == "fr")
end
if Settings.Opacity==nil then
	Settings.Opacity=1
end

if Settings.DefaultLanguage==nil then Settings.DefaultLanguage=language end
if Settings.CurrentLanguage==nil then Settings.CurrentLanguage=Settings.DefaultLanguage end
if showTime then Turbine.Shell.WriteLine("load StoryList:"..tostring(Turbine.Engine:GetLocalTime())) end

StoryList=PatchDataLoad(Turbine.DataScope.Account, pluginName.."StoryList");
if StoryList==nil then StoryList={} end
for k,v in ipairs(StoryList) do
	if v.ID==nil then
		v.ID=Settings.MaxID+1
		Settings.MaxID=v.ID
	end
	if v.ID>Settings.MaxID then Settings.MaxID=v.ID end
end

ReaderSettings=PatchDataLoad(Turbine.DataScope.Account, pluginName.."ReaderSettings")
if ReaderSettings==nil then ReaderSettings={} end
if Settings.ReaderWindow==nil then Settings.ReaderWindow={} end
if ReaderSettings.ReaderWindow==nil then ReaderSettings.ReaderWindow={} end

import (importPath.."DropDownList");
import (importPath.."RadioButtonGroup");
import (importPath.."FontSupport")
fontMetric=FontMetric()
fontMetric:SetFont(Settings.Font)
import (importPath.."DebugWindow");
import (importPath.."PopUpDialog");
import (importPath.."IconWindow")
import (importPath.."Settings")
import (importPath.."StorySelect")
import (importPath.."ImageViewer")

getStoryIndexFromID=function(id)
	local index
	for k,v in ipairs(StoryList) do
		if v.ID==id then
			index=k
			break
		end
	end
	return index
end

readerStory={}
readerStory.Chapters={}
if showTime then Turbine.Shell.WriteLine("define readerWindow:"..tostring(Turbine.Engine:GetLocalTime())) end

readerWindow=Turbine.UI.Lotro.Window()
readerWindow:SetResizable(true)
readerWindow:SetMinimumSize(885,290)
readerWindow:SetOpacity(Settings.Opacity)
readerWindow.Paused=false
readerWindow.ObjectiveItems={}
readerWindow.ObjectiveMessages={}
readerWindow.ObjectiveEffects={}

readerWindow.Callbacks={} -- table of active registered callbacks (we only register callbacks when a story is active and one or more of the objectives requires that callback)

if ReaderSettings.ReaderWindow.Width==nil then
	ReaderSettings.ReaderWindow.Width=.67
end
if ReaderSettings.ReaderWindow.Height==nil then
	ReaderSettings.ReaderWindow.Height=.5
end
if ReaderSettings.ReaderWindow.Top==nil then
	ReaderSettings.ReaderWindow.Top=(1-ReaderSettings.ReaderWindow.Height)/2
end
if ReaderSettings.ReaderWindow.Left==nil then
	ReaderSettings.ReaderWindow.Left=(1-ReaderSettings.ReaderWindow.Height)/2
end
if ReaderSettings.ReaderWindow.Width<(readerWindow:GetMinimumWidth()/displayWidth) then ReaderSettings.ReaderWindow.Width=readerWindow:GetMinimumWidth()/displayWidth end
if ReaderSettings.ReaderWindow.Height<(readerWindow:GetMinimumHeight()/displayHeight) then ReaderSettings.ReaderWindow.Height=readerWindow:GetMinimumHeight()/displayWidth end

if ReaderSettings.ReaderSplit==nil then
	ReaderSettings.ReaderSplit=1-(400/displayWidth)
end
if ReaderSettings.ShowTracker==nil then
	ReaderSettings.ShowTracker=true
end

if Settings.LoadLastStory==nil then Settings.LoadLastStory=true end
if Settings.ReaderStoryID==nil and Settings.LoadLastStory and Settings.ReaderWindow.LastStory~=nil then
	readerWindow.currentStoryID=Settings.ReaderWindow.LastStory
if showTime then Turbine.Shell.WriteLine("reading story:"..tostring(Turbine.Engine:GetLocalTime())) end
	readerStory=PatchDataLoad(Turbine.DataScope.Account,pluginName.."Story"..readerWindow.currentStoryID)
if showTime then Turbine.Shell.WriteLine("story read:"..tostring(Turbine.Engine:GetLocalTime())) end
	if readerStory==nil then readerStory={} end
elseif Settings.ReaderStoryID~=nil then
	readerWindow.currentStoryID=Settings.ReaderStoryID
if showTime then Turbine.Shell.WriteLine("reading story:"..tostring(Turbine.Engine:GetLocalTime())) end
	readerStory=PatchDataLoad(Turbine.DataScope.Account,pluginName.."Story"..readerWindow.currentStoryID)
if showTime then Turbine.Shell.WriteLine("story read:"..tostring(Turbine.Engine:GetLocalTime())) end
end
if readerStory==nil then readerStory={} end
if readerStory.ImageRoot==nil then
	readerStory.ImageRoot=storyPath -- default image root to the story path
end
Settings.ImageRoot=readerStory.ImageRoot

if showTime then Turbine.Shell.WriteLine("setting readerWindow size and position:"..tostring(Turbine.Engine:GetLocalTime())) end
readerWindow:SetSize(ReaderSettings.ReaderWindow.Width*displayWidth,ReaderSettings.ReaderWindow.Height*displayHeight)
readerWindow:SetPosition(ReaderSettings.ReaderWindow.Left*displayWidth,ReaderSettings.ReaderWindow.Top*displayHeight)

readerWindow:SetText(Resource[language][2].." - "..Resource[language][5])
readerWindow.Closed=function()
	readerWindow.ObjectiveBorder:SetParent(objectiveTracker)
	readerWindow.ObjectiveListVScroll:SetParent(objectiveTracker)
	readerWindow.RefreshObjectives()
	objectiveTracker:SetVisible(ReaderSettings.ShowTracker)
	iconWindow:SetVisible(true)
end

if showTime then Turbine.Shell.WriteLine("creating readerWindow menu buttons:"..tostring(Turbine.Engine:GetLocalTime())) end
readerWindow.LoadButton=Turbine.UI.Lotro.Button()
readerWindow.LoadButton:SetParent(readerWindow)
readerWindow.LoadButton:SetHeight(20)
readerWindow.LoadButton:SetPosition(30,35)
readerWindow.LoadButton.Click=function()
	readerWindow.Message:SetText("")
	storySelect.currentStoryID=readerWindow.currentStoryID
	storySelect.ReturnSelected=readerWindow.StorySelected
	storySelect.CurrLanguage:SetSelectedIndex(Settings.CurrentLanguage)
	storySelect.CurrLanguage.SelectedIndexChanged()
--	storySelect.FillStoryList(storySelect.StoryListBox.SortColumn)
	storySelect:SetVisible(true)
	readerWindow.MouseMask:SetMouseVisible(true) -- note, MouseMask is used to simulate modal dialogs
end
readerWindow.LoadButton.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][229])
end
readerWindow.LoadButton.MouseLeave=function()
	readerWindow.Message:SetText("")
end

readerWindow.PauseButton=Turbine.UI.Lotro.Button()
readerWindow.PauseButton:SetParent(readerWindow)
readerWindow.PauseButton:SetHeight(20)
readerWindow.PauseButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.PauseButton.MouseEnter=function()
	if readerWindow.Paused then
		readerWindow.Message:SetText(Resource[language][116])
	else
		readerWindow.Message:SetText(Resource[language][115])
	end
end
readerWindow.PauseButton.MouseLeave=function()
	readerWindow.Message:SetText("")
end
readerWindow.PauseButton.Click=function()
	readerWindow.Paused=not readerWindow.Paused
	if readerWindow.Paused then
		readerWindow.PauseButton:SetText(Resource[language][74])
		-- disable all of the event handlers
		readerWindow.PausedMessage:SetVisible(true)
		for k,v in pairs(readerWindow.Callbacks) do
			if v.Object~=nil then
				RemoveCallback(v.Object,v.Event,v.Function)
			end
		end
	else
		readerWindow.PauseButton:SetText(Resource[language][73])
		-- re-enable all of the event handlers
		readerWindow.PausedMessage:SetVisible(false)
		for k,v in pairs(readerWindow.Callbacks) do
			if v.Object~=nil then
				AddCallback(v.Object,v.Event,v.Function)
			end
		end
		-- fire TargetChanged just in case we already have a target
		readerWindow.TargetChanged()
		-- fire quantityChanged once to resynch inventory
		readerWindow.BackpackUpdateQuantity()
	end
	readerWindow.LoadButton:SetEnabled(not readerWindow.Paused)
	readerWindow.ResetButton:SetEnabled(not readerWindow.Paused)
	readerWindow.HistoryButton:SetEnabled(not readerWindow.Paused)
end
readerWindow.ResetButton=Turbine.UI.Lotro.Button()
readerWindow.ResetButton:SetParent(readerWindow)
readerWindow.ResetButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.ResetButton.Click=function()
	readerWindow.MouseMask:SetMouseVisible(true)
	confirmReset=PopUpDialog(Resource[language][80],Resource[language][81],4,Resource[language][32],Resource[language][19],nil,false,readerResetOK)
end
readerResetOK=function(flag)
	readerWindow.MouseMask:SetMouseVisible(false)
	if flag==1 then
		readerWindow.ActiveChapter=nil
		local index=getStoryIndexFromID(readerWindow.currentStoryID)
		StoryList[index].ActiveChapter=nil
		StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
		readerDisplayStory()
		readerWindow.Message:SetText(Resource[language][79])
	end
	confirmReset=nil
end
readerWindow.ResetButton.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][227])
end
readerWindow.ResetButton.MouseLeave=function()
	readerWindow.Message:SetText("")
end

readerWindow.HistoryButton=Turbine.UI.Lotro.Button()
readerWindow.HistoryButton:SetParent(readerWindow)
readerWindow.HistoryButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.HistoryButton.Click=function()
	-- show the History window, which will show all of the text of prior chapters and the choices with Status
	readerWindow.MouseMask:SetMouseVisible(true)
	infoPopUp=PopUpDialog("History Placeholder","The History window is not currently available. It will display all prior story text. The user will be able to read all of the story text that they already encountered and retrace their selected path.",4,Resource[language][32],nil,nil,false,readerWindow.CloseInfo)
end
readerWindow.HistoryButton.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][228])
end
readerWindow.HistoryButton.MouseLeave=function()
	readerWindow.Message:SetText("")
end

readerWindow.CurrLanguage=DropDownList()
readerWindow.CurrLanguage:SetZOrder(2)
readerWindow.CurrLanguage:SetParent(readerWindow)
readerWindow.CurrLanguage:AddItem(Resource[language][209],1)
readerWindow.CurrLanguage:AddItem(Resource[language][210],2)
readerWindow.CurrLanguage:AddItem(Resource[language][211],3)

readerWindow.CurrLanguage.SelectedIndexChanged=function()
	if readerWindow.CurrLanguage:GetValue()==2 then
		Settings.CurrentLanguage=2
	elseif readerWindow.CurrLanguage:GetValue()==3 then
		Settings.CurrentLanguage=3
	else
		Settings.CurrentLanguage=1
	end
	-- redisplay the story (to get storyname translated as well as active chapter
	readerDisplayStory()
end

readerWindow.MenuButton=Turbine.UI.Lotro.Button()
readerWindow.MenuButton:SetParent(readerWindow)
readerWindow.MenuButton:SetHeight(20)
readerWindow.MenuButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.MenuButton.Click=function()
	SaveSetting("Account",pluginName.."Settings","","Mode","Menu") -- trigger reload
	-- need to save reader settings
	SaveSettings()
	SettingQueueCallback(loadMenu)
end
loadMenu=function()
	Turbine.PluginManager.LoadPlugin("Anthology")
	readerWindow:SetVisible(false)
end
readerWindow.MenuButton.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][230])
end
readerWindow.MenuButton.MouseLeave=function()
	readerWindow.Message:SetText("")
end

if showTime then Turbine.Shell.WriteLine("creating readerWindow panes:"..tostring(Turbine.Engine:GetLocalTime())) end
readerWindow.Story=Turbine.UI.Label()
readerWindow.Story:SetParent(readerWindow)
readerWindow.Story:SetLeft(10)
readerWindow.Chapter=Turbine.UI.Label()
readerWindow.Chapter:SetParent(readerWindow)
readerWindow.Chapter:SetLeft(readerWindow.Story:GetLeft())

readerWindow.Split=Turbine.UI.Control()
readerWindow.Split:SetParent(readerWindow)
readerWindow.Split:SetWidth(4)
readerWindow.Split:SetBackground(resourcePath.."vsep.tga")
readerWindow.Split:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
readerWindow.Split.MouseDown=function(sender,args)
	readerWindow.MovingSplit=true
	readerWindow.SplitX=args.X
end
readerWindow.Split.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][114])
end
readerWindow.Split.MouseLeave=function()
	readerWindow.Message:SetText("")
end
readerWindow.Split.MouseUp=function(sender,args)
	readerWindow.MovingSplit=false
end
readerWindow.Split.MouseMove=function(sender,args)
	if readerWindow.MovingSplit then
		ReaderSettings.ReaderSplit=(readerWindow.Split:GetLeft()+args.X-readerWindow.SplitX)/readerWindow:GetWidth()
		if ReaderSettings.ReaderSplit>.9 then ReaderSettings.ReaderSplit=.9 end
		if ReaderSettings.ReaderSplit<.1 then ReaderSettings.ReaderSplit=.1 end
		readerWindow.RefreshLayout()
	end
end

readerWindow.TextBorder=Turbine.UI.Control()
readerWindow.TextBorder:SetParent(readerWindow)
readerWindow.TextBorder:SetLeft(10)
readerWindow.Text=Turbine.UI.ListBox()
readerWindow.Text:SetParent(readerWindow.TextBorder)
readerWindow.Text:SetPosition(1,1)
readerWindow.TextVScroll=Turbine.UI.Lotro.ScrollBar()
readerWindow.TextVScroll:SetParent(readerWindow)
readerWindow.TextVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
readerWindow.TextVScroll:SetWidth(10)
readerWindow.TextVScroll:SetTop(readerWindow.Text:GetTop())
readerWindow.Text:SetVerticalScrollBar(readerWindow.TextVScroll)

readerWindow.ObjectiveBorder=Turbine.UI.Control()
readerWindow.ObjectiveBorder:SetParent(readerWindow)
readerWindow.ObjectiveBorder:SetMouseVisible(false)
readerWindow.ObjectiveList=Turbine.UI.ListBox()
readerWindow.ObjectiveList:SetParent(readerWindow.ObjectiveBorder)
readerWindow.ObjectiveList:SetPosition(1,1)
readerWindow.ObjectiveList:SetMouseVisible(false)
readerWindow.ObjectiveListVScroll=Turbine.UI.Lotro.ScrollBar()
readerWindow.ObjectiveListVScroll:SetParent(readerWindow)
readerWindow.ObjectiveListVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
readerWindow.ObjectiveListVScroll:SetWidth(10)
readerWindow.ObjectiveList:SetVerticalScrollBar(readerWindow.ObjectiveListVScroll)

readerWindow.PausedMessage=Turbine.UI.Label()
readerWindow.PausedMessage:SetParent(readerWindow)
readerWindow.PausedMessage:SetText(Resource[language][75])
readerWindow.PausedMessage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
readerWindow.PausedMessage:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
readerWindow.PausedMessage:SetBackColor(Turbine.UI.Color(.7,0,0,0))
readerWindow.PausedMessage:SetVisible(false)

readerWindow.Message=Turbine.UI.Label()
readerWindow.Message:SetParent(readerWindow)
readerWindow.Message:SetLeft(25)
readerWindow.Message:SetForeColor(Turbine.UI.Color.Gray)

readerWindow.TextIcon=Turbine.UI.Control()
readerWindow.TextIcon:SetParent(readerWindow)
readerWindow.TextIcon:SetSize(23,20)
readerWindow.TextIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
readerWindow.TextIcon:SetBackground(resourcePath.."TextIcon.jpg")
readerWindow.TextIcon.MouseClick=function()
	SettingQueueCallback(readerWindow.ShowFontSelect) -- use callback to eliminate odd behaviour when window is not in focus before click
end
readerWindow.ShowFontSelect=function()
	readerWindow.MouseMask:SetMouseVisible(true)
	readerWindow.FontSelect:MouseClick()
end
if showTime then Turbine.Shell.WriteLine("creating readerWindow.FontSelect:"..tostring(Turbine.Engine:GetLocalTime())) end

readerWindow.FontSelect=FontSelect()
readerWindow.FontSelect:SetParent(readerWindow)
readerWindow.FontSelect:SetSize(0,0)
readerWindow.FontSelect:SetFont(Settings.Font)
readerWindow.FontSelect.FontChanged=function(sender,args)
	readerWindow.MouseMask:SetMouseVisible(false)
	Settings.Font=readerWindow.FontSelect:GetFont()
	readerWindow.RefreshLayout()
	SaveSetting("Account",pluginName.."Settings","","Font",Settings.Font)
end
readerWindow.TextIcon.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][226])
end
readerWindow.TextIcon.MouseLeave=function()
	readerWindow.Message:SetText("")
end

if showTime then Turbine.Shell.WriteLine("creating readerWindow mouse mask:"..tostring(Turbine.Engine:GetLocalTime())) end

readerWindow.MouseMask=Turbine.UI.Control()
readerWindow.MouseMask:SetParent(readerWindow)
readerWindow.MouseMask:SetMouseVisible(false)
readerWindow.MouseMask:SetZOrder(2)
readerWindow.MouseMask:SetSize(readerWindow:GetSize())
readerWindow.MouseMask.MouseClick=function()
	if FontSelectList:IsVisible() then
		FontSelectList:SetVisible(false)
		readerWindow.MouseMask:SetMouseVisible(false)
	end
end

readerWindow.RefreshLayout=function()
if showTime then Turbine.Shell.WriteLine("refreshLayout:"..tostring(Turbine.Engine:GetLocalTime())) end
	local minButtonWidth=140
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	fontMetric:SetFont(buttonFont)
	local tmp=fontMetric:GetTextWidth(Resource[language][72])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][73])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][74])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][7])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][79])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][88])
	if tmp>minButtonWidth then minButtonWidth=tmp end

	readerWindow.LoadButton:SetSize(minButtonWidth)
	readerWindow.LoadButton:SetFont(buttonFont)
	readerWindow.LoadButton:SetText(Resource[language][72])

	readerWindow.PauseButton:SetSize(minButtonWidth)
	readerWindow.PauseButton:SetLeft(readerWindow.LoadButton:GetLeft()+readerWindow.LoadButton:GetWidth()+5)
	readerWindow.PauseButton:SetFont(buttonFont)
	if readerWindow.Paused then
		readerWindow.PauseButton:SetText(Resource[language][74])
	else
		readerWindow.PauseButton:SetText(Resource[language][73])
	end

	readerWindow.ResetButton:SetSize(minButtonWidth)
	readerWindow.ResetButton:SetLeft(readerWindow.PauseButton:GetLeft()+readerWindow.PauseButton:GetWidth()+5)
	readerWindow.ResetButton:SetFont(buttonFont)
	readerWindow.ResetButton:SetText(Resource[language][79])

	readerWindow.HistoryButton:SetSize(minButtonWidth)
	readerWindow.HistoryButton:SetLeft(readerWindow.ResetButton:GetLeft()+readerWindow.ResetButton:GetWidth()+5)
	readerWindow.HistoryButton:SetFont(buttonFont)
	readerWindow.HistoryButton:SetText(Resource[language][88])

	readerWindow.MenuButton:SetSize(minButtonWidth)
	readerWindow.MenuButton:SetLeft(readerWindow:GetWidth()-readerWindow.MenuButton:GetWidth()-readerWindow.LoadButton:GetLeft())
	readerWindow.MenuButton:SetFont(buttonFont)
	readerWindow.MenuButton:SetText(Resource[language][7])

	fontMetric:SetFont(Settings.Font)
	readerWindow.CurrLanguage:SetSize(fontMetric:GetTextWidth("WW")+35,controlHeight)
	readerWindow.CurrLanguage:SetPosition(readerWindow.MenuButton:GetLeft()-readerWindow.CurrLanguage:GetWidth()-5,readerWindow.MenuButton:GetTop())
	readerWindow.CurrLanguage:SetFont(Settings.Font)

	readerWindow.Story:SetTop(readerWindow.LoadButton:GetTop()+readerWindow.LoadButton:GetHeight()+5)
	readerWindow.Story:SetSize(readerWindow:GetWidth()-20,controlHeight)
	readerWindow.Story:SetFont(Settings.Font)
	readerWindow.Story:SetText(readerWindow.Story:GetText())
	readerWindow.Chapter:SetTop(readerWindow.Story:GetTop()+readerWindow.Story:GetHeight()+5)
	readerWindow.Chapter:SetSize(readerWindow:GetWidth()-20,controlHeight)
	readerWindow.Chapter:SetFont(Settings.Font)
	readerWindow.Chapter:SetText(readerWindow.Chapter:GetText())

	readerWindow.Split:SetPosition(ReaderSettings.ReaderSplit*readerWindow:GetWidth(),readerWindow.Chapter:GetTop()+readerWindow.Chapter:GetHeight()+5) -- split is a percent
	readerWindow.Split:SetHeight(readerWindow:GetHeight()-readerWindow.Split:GetTop()-controlHeight-15)

	readerWindow.TextBorder:SetTop(readerWindow.Split:GetTop())
	readerWindow.TextBorder:SetSize(readerWindow.Split:GetLeft()-readerWindow.TextBorder:GetLeft()-11,readerWindow.Split:GetHeight())
	readerWindow.Text:SetSize(readerWindow.TextBorder:GetWidth()-2,readerWindow.TextBorder:GetHeight()-2)

	for k=1,readerWindow.Text:GetItemCount() do
		local tmpItem=readerWindow.Text:GetItem(k)
		tmpItem:SetWidth(readerWindow.Text:GetWidth())
		if tmpItem.Type=="Text" then
			tmpItem:SetHeight(fontMetric:GetTextHeight(tmpItem:GetText(),readerWindow.Text:GetWidth()))
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetText(tmpItem:GetText())
		elseif tmpItem.Type=="Image" then
			if readerWindow.Text:GetWidth()>=tmpItem.Image.Width then
				tmpItem.Image:SetBackground(tmpItem.Image.File)
				tmpItem.Image:SetSize(tmpItem.Image.Width,tmpItem.Image.Height)
				tmpItem:SetHeight(tmpItem.Image.Height)
			else
				tmpItem.Image:SetBackground(resourcePath.."ImageIcon.tga")
				tmpItem.Image:SetSize(32,32)
				tmpItem:SetHeight(32)
			end
			tmpItem.Image:SetLeft((readerWindow.Text:GetWidth()-tmpItem.Image:GetWidth())/2)
		end
	end
	readerWindow.TextVScroll:SetPosition(readerWindow.TextBorder:GetLeft()+readerWindow.TextBorder:GetWidth(),readerWindow.TextBorder:GetTop())
	readerWindow.TextVScroll:SetHeight(readerWindow.TextBorder:GetHeight())

	readerWindow.PausedMessage:SetSize(readerWindow.ObjectiveBorder:GetWidth()+10,readerWindow.ObjectiveBorder:GetHeight())
	readerWindow.PausedMessage:SetPosition(readerWindow.ObjectiveBorder:GetPosition())
	readerWindow.PausedMessage:SetFont(Settings.Font)
	readerWindow.PausedMessage:SetText(readerWindow.PausedMessage:GetText())
	readerWindow.Message:SetTop(readerWindow:GetHeight()-controlHeight-10)
	readerWindow.Message:SetSize(readerWindow:GetWidth()-readerWindow.Message:GetLeft()*2,controlHeight)
	readerWindow.Message:SetFont(Settings.Font)
	readerWindow.Message:SetText(readerWindow.Message:GetText())

	readerWindow.TextIcon:SetPosition(readerWindow:GetWidth()-50,readerWindow:GetHeight()-30)
	readerWindow.FontSelect:SetPosition(readerWindow:GetWidth()-readerWindow.FontSelect:GetWidth()-50,readerWindow:GetHeight()-5-controlHeight)
	readerWindow.MouseMask:SetSize(readerWindow:GetSize())
	readerWindow.RefreshObjectives()
end

readerWindow.RefreshObjectives=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	-- the objectives are refreshed seperately so that the list can be shown in the reader window or the objective tracker window
	if readerWindow.ObjectiveBorder:GetParent()==objectiveTracker then
		readerWindow.ObjectiveBorder:SetPosition(10,35)
		readerWindow.ObjectiveBorder:SetSize(objectiveTracker:GetWidth()-30,objectiveTracker:GetHeight()-60)
	else
		readerWindow.ObjectiveBorder:SetPosition(readerWindow.Split:GetLeft()+readerWindow.Split:GetWidth()+3,readerWindow.TextBorder:GetTop())
		readerWindow.ObjectiveBorder:SetSize(readerWindow:GetWidth()-readerWindow.ObjectiveBorder:GetLeft()-22,readerWindow.Text:GetHeight())
	end
	readerWindow.ObjectiveList:SetSize(readerWindow.ObjectiveBorder:GetWidth()-2,readerWindow.ObjectiveBorder:GetHeight()-2)
	readerWindow.ObjectiveListVScroll:SetPosition(readerWindow.ObjectiveBorder:GetLeft()+readerWindow.ObjectiveBorder:GetWidth(),readerWindow.ObjectiveBorder:GetTop())
	readerWindow.ObjectiveListVScroll:SetHeight(readerWindow.ObjectiveList:GetHeight())
	local objWidth=readerWindow.ObjectiveList:GetWidth()
	for k=1,readerWindow.ObjectiveList:GetItemCount() do
		local tmpItem=readerWindow.ObjectiveList:GetItem(k)
		local height2=0
		fontMetric:SetFont(Settings.Font)
		local height=fontMetric:GetTextHeight(tmpItem:GetText(),objWidth)
		if tmpItem.CheckMark~=nil then
			-- add checkmark 1091437784
			tmpItem.CheckMark:SetPosition(0,height)
			height2=tmpItem.CheckMark:GetHeight()
		end
		if tmpItem.Button~=nil then
			tmpItem.Button:SetPosition((objWidth-tmpItem.Button:GetWidth())/2,height)
			tmpItem.Button:SetFont(buttonFont)
			fontMetric:SetFont(buttonFont)
			tmpItem.Button:SetWidth(fontMetric:GetTextWidth(tmpItem.Button:GetText())+20)
			tmpItem.Button:SetText(tmpItem.Button:GetText())
			height2=tmpItem.Button:GetHeight()
		end
		if tmpItem.CountLabel~=nil then
			tmpItem.CountLabel:SetFont(Settings.Font)
			tmpItem.CountLabel:SetText(tmpItem.CountLabel:GetText())
			tmpItem.CountLabel:SetPosition(0,height)
			if controlHeight>height2 then height2=controlHeight end
			tmpItem.CountLabel:SetHeight(controlHeight)
			tmpItem.CountLabel:SetWidth(objWidth)
		end
		if tmpItem.QS~=nil then
			tmpItem.QS:SetSize(fontMetric:GetTextWidth(Resource[language][222])+20,22)
			tmpItem.QS:SetPosition((readerWindow.ObjectiveList:GetWidth()-tmpItem.QS:GetWidth())/2,height)
			tmpItem.ButtonBack:SetSize(tmpItem.QS:GetWidth(),22)
			tmpItem.ButtonBack:SetPosition(tmpItem.QS:GetPosition())
			tmpItem.LocButton:SetSize(tmpItem.ButtonBack:GetWidth()-2,tmpItem.ButtonBack:GetHeight()-2)
			if 22>height2 then height2=22 end
		end
		height=height+height2
		tmpItem:SetFont(Settings.Font)
		tmpItem:SetText(tmpItem:GetText())
		tmpItem:SetSize(objWidth,height+controlHeight)
		
	end
end
readerWindow.RefreshLayout()
readerWindow.SizeChanged=function(sernder,args)
	readerWindow.RefreshLayout()
end
readerWindow.RefreshColor=function()
if showTime then Turbine.Shell.WriteLine("refreshColor:"..tostring(Turbine.Engine:GetLocalTime())) end
	readerWindow.CurrLanguage:SetBorderColor(Settings.TrimColor)
	readerWindow.CurrLanguage:SetBackColor(Settings.BackColor)
	readerWindow.CurrLanguage.CurrentValue:SetBackColor(Settings.BackColor)
	readerWindow.CurrLanguage:SetTextColor(Settings.FontColor)
	readerWindow.Story:SetForeColor(Settings.LabelColor)
	readerWindow.Chapter:SetForeColor(Settings.LabelColor)
	readerWindow.Split:SetBackColor(Settings.TrimColor)
	readerWindow.TextBorder:SetBackColor(Settings.TrimColor)
	readerWindow.Text:SetBackColor(Settings.BackColor)
	readerWindow.ObjectiveBorder:SetBackColor(Settings.TrimColor)
	readerWindow.ObjectiveList:SetBackColor(Settings.BackColor)
end
readerWindow.RefreshColor()

readerWindow.StorySelected=function()
	SaveSetting("Account",pluginName.."Settings","","ReaderStoryID",storySelect.SelectedID) -- save story id
	SaveSetting("Account",pluginName.."Settings","","Mode","Reader") -- trigger reload
	SaveSettings()
	SettingQueueCallback(loadMenu)
end
SaveSettings=function()
	SaveSetting("Account",pluginName.."Settings","ReaderWindow","LastStory",readerWindow.currentStoryID)
	SaveSetting("Account",pluginName.."Settings","IconWindow","Left",iconWindow:GetLeft()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","IconWindow","Top",iconWindow:GetTop()/displayHeight)
end
readerCheckTimeStamps=function()
if showTime then Turbine.Shell.WriteLine("readerCheckTimeStamps:"..tostring(Turbine.Engine:GetLocalTime())) end
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	if index~=nil and StoryList[index].ActiveChapter~=nil then
		-- check timestamps
		local index=getStoryIndexFromID(readerWindow.currentStoryID)
		local lastEdit=readerStory.LastEditTime
		if lastEdit==nil then lastEdit=0 end -- should only happen with test files
		local lastRead=StoryList[index].LastReadTime
		if lastRead~=nil and lastEdit>lastRead then
			readerWindow.MouseMask:SetMouseVisible(true)
			confirmReset=PopUpDialog(Resource[language][110],Resource[language][111],4,Resource[language][86],Resource[language][87],nil,false,readerOfferReset)
		else
			readerDisplayStory()
		end
	else
		readerDisplayStory()
	end
end
readerOfferReset=function(flag)
	readerWindow.MouseMask:SetMouseVisible(false)
	confirmReset=nil
	if flag==1 then
		readerWindow.ActiveChapter=nil
		local index=getStoryIndexFromID(readerWindow.currentStoryID)
		StoryList[index].ActiveChapter=nil
		StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
		readerDisplayStory()
		readerWindow.Message:SetText(Resource[language][79])
	else
		readerDisplayStory()
	end
end
readerDisplayStory=function()
if showTime then Turbine.Shell.WriteLine("readerDisplayStory:"..tostring(Turbine.Engine:GetLocalTime())) end
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end
	-- set readerWindow.CurrLanguage entries based on supported languages
	if readerStory.DE then
		readerWindow.CurrLanguage:ShowEntry(3)
	else
		readerWindow.CurrLanguage:HideEntry(3)
	end
	if readerStory.FR then
		readerWindow.CurrLanguage:ShowEntry(2)
	else
		readerWindow.CurrLanguage:HideEntry(2)
	end
	if readerStory.EN then
		readerWindow.CurrLanguage:ShowEntry(1)
	else
		readerWindow.CurrLanguage:HideEntry(1)
	end
	-- now coerce CurrentLanguage into one of the supported languages
	if (Settings.CurrentLanguage==1 and not readerStory.EN) or (Settings.CurrentLanguage==2 and not readerStory.FR) or (Settings.CurrentLanguage==3 and not readerStory.DE) then
		if (Settings.DefaultLanguage==1 and readerStory.EN) or (Settings.DefaultLanguage==2 and readerStory.FR) or (Settings.DefaultLanguage==3 and readerStory.DE) then
			Settings.CurrentLanguage=Settings.DefaultLanguage
		else
			if (language==1 and readerStory.EN) or (language==2 and readerStory.FR) or (language==3 and readerStory.DE) then
				Settings.CurrentLanguage=language
			else
				if readerStory.EN then
					Settings.CurrentLanguage=1
				elseif readerStory.FR then
					Settings.CurrentLanguage=2
				elseif readerStory.DE then
					Settings.CurrentLanguage=3
				else
					Settings.CurrentLanguage=1
				end
			end
		end
	end
	if (language==1 and not readerStory.EN) or (language==2 and not readerStory.FR) or (language==3 and not readerStory.DE) then
		-- warn user that the game client language is not supported by the story.
		languagePopUp=PopUpDialog(Resource[language][223],Resource[language][224],4,Resource[language][32],nil,nil,false,languagePopUpOK)
	end
	readerWindow.CurrLanguage:SetSelectedIndex(Settings.CurrentLanguage)
	readerWindow.MouseMask:SetMouseVisible(false)
	local tmp=""
	if readerStory.Author~=nil then tmp=tmp..readerStory.Author end
	if Settings.CurrentLanguage==2 then
		if readerStory.Name~=nil then tmp=tmp..": "..readerStory.NameFR end
	elseif Settings.CurrentLanguage==3 then
		if readerStory.Name~=nil then tmp=tmp..": "..readerStory.NameDE end
	else
		if readerStory.Name~=nil then tmp=tmp..": "..readerStory.Name end
	end
	if readerStory.Chapters==nil then readerStory.Chapters={} end
	readerWindow.Story:SetText(tmp)
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	readerWindow.ActiveChapter=StoryList[index].ActiveChapter
	readerWindow.ObjectiveList:ClearItems()
	readerWindow.Text:ClearItems()
	if readerWindow.ActiveChapter~=nil then
		readerDisplayActiveChapter()
	else
		-- remove any active callbacks
		for k,v in pairs(readerWindow.Callbacks) do
			if v.Object~=nil then
				RemoveCallback(v.Object,v.Event,v.Function)
			end
			readerWindow.Callbacks[k]=nil
		end
		readerWindow.Chapter:SetText("")
		local tmpItem=Turbine.UI.Label()
		tmpItem:SetParent(readerWindow.Text)
		local tmpText
		if Settings.CurrentLanguage==2 then
			tmpText=resolveText(readerStory.DescFR)
		elseif Settings.CurrentLanguage==3 then
			tmpText=resolveText(readerStory.DescDE)
		else
			tmpText=resolveText(readerStory.Desc)
		end
		tmpItem:SetFont(Settings.Font)
		fontMetric:SetFont(Settings.Font)
		tmpItem:SetSize(readerWindow.Text:GetWidth(),fontMetric:GetTextHeight(tmpText,readerWindow.Text:GetWidth()))
		tmpItem:SetForeColor(Settings.FontColor)
		tmpItem:SetText(tmpText)
		tmpItem.Type="Text"
		readerWindow.Text:AddItem(tmpItem)
		-- find first chapter
		local first
		for k,v in pairs(readerStory.Chapters) do
			if v.DisplayOrder==1 then
				first=k
				break
			end
		end
		-- add a "Start Story" button
		if first~=nil then
			local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
			local tmpItem=Turbine.UI.Label()
			tmpItem:SetParent(readerWindow.Objectives)
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetWidth(readerWindow.ObjectiveList:GetWidth())
			fontMetric:SetFont(Settings.Font)
			local height=fontMetric:GetTextHeight(Resource[language][76],tmpItem:GetWidth())
			tmpItem:SetText(Resource[language][76])
			tmpItem:SetMouseVisible(false)
--			tmpItem.MouseClick=function() readerStartStory(first) end
			tmpItem.Button=Turbine.UI.Lotro.Button()
			tmpItem.Button:SetParent(tmpItem)
			tmpItem.Button:SetFont(buttonFont)
			fontMetric:SetFont(buttonFont)
			tmpItem.Button:SetWidth(fontMetric:GetTextWidth(Resource[language][77])+20)
			tmpItem.Button:SetPosition((readerWindow.ObjectiveList:GetWidth()-tmpItem.Button:GetWidth())/2,height)
			tmpItem.Button:SetText(Resource[language][77])
			tmpItem.Button.Click=function() readerStartStory(first) end
			tmpItem:SetHeight(height+20+controlHeight)
			readerWindow.ObjectiveList:AddItem(tmpItem)
		end
	end
	readerWindow.Message:SetText(Resource[language][24])
end
readerSetImage=function(control)
	local tmpImage=Turbine.UI.Control() -- use a temp image to get size since using SetStretchMode causes image to draw outside it's owner even after set back to 0
	-- generate an image
	local imageFile=control.ImagePath
	if imageFile~="" then
		if string.sub(imageFile,-1)~="/" then
			imageFile=imageFile.."/"
		end
	end
	local tmpName=control.FileName
	if imageFile=="" and tonumber(tmpName)~=nil and tonumber(tmpName)>0 then
		imageFile=tonumber(tmpName)
	else
		imageFile=imageFile..control.FileName
	end
	local success,result=pcall(Turbine.UI.Control.SetBackground,tmpImage,imageFile)
	if success then
		control.File=imageFile
		control:SetVisible(true)
		tmpImage:SetStretchMode(2)
		control.Width,control.Height=tmpImage:GetSize()
		if control.Width>readerWindow.Text:GetWidth() then
			-- image is too big, show icon
			control:SetBackground(resourcePath.."ImageIcon.tga")
			control:SetSize(32,32)
		else
			control:SetBackground(imageFile)
			control:SetSize(control.Width,control.Height)
		end
	else
		control.File=resourcePath.."ImageError.tga"
		control:SetBackground(resourcePath.."ImageError.tga")
		control:SetSize(32,32)
		control.Width=32
		control.Height=32
	end
	control:GetParent():SetHeight(control:GetHeight())
	control:SetLeft((readerWindow.Text:GetWidth()-control:GetWidth())/2)
end
readerDisplayActiveChapter=function()
if showTime then Turbine.Shell.WriteLine("readerDisplayActiveChapter:"..tostring(Turbine.Engine:GetLocalTime())) end
	-- remove all active callbacks
	for k,v in pairs(readerWindow.Callbacks) do
		if v.Object~=nil then
			RemoveCallback(v.Object,v.Event,v.Function)
		end
		readerWindow.Callbacks[k]=nil
	end
	readerWindow.Text:ClearItems()
	if readerWindow.ActiveChapter~=nil then
		if Settings.CurrentLanguage==2 then
			readerWindow.Chapter:SetText(readerStory.Chapters[readerWindow.ActiveChapter].NameFR)
		elseif Settings.CurrentLanguage==3 then
			readerWindow.Chapter:SetText(readerStory.Chapters[readerWindow.ActiveChapter].NameDE)
		else
			readerWindow.Chapter:SetText(readerStory.Chapters[readerWindow.ActiveChapter].Name)
		end
		for k,v in ipairs(readerStory.Chapters[readerWindow.ActiveChapter].Content) do
			local newHeight=controlHeight
			local newWidth=readerWindow.Text:GetWidth()
			local item
			if v.Type=="Text" then
				item=Turbine.UI.Label()
				item:SetSelectable(true)
				item:SetForeColor(Settings.FontColor)
				item:SetFont(Settings.Font)
				item:SetMultiline(true)
				local tmpText
				if readerWindow.CurrLanguage:GetValue()==2 then
					tmpText=resolveText(v.TextFR)
				elseif readerWindow.CurrLanguage:GetValue()==3 then
					tmpText=resolveText(v.TextDE)
				else
					tmpText=resolveText(v.Text)
				end
				if tmpText~=nil then
					item:SetText(tmpText)
					newHeight=fontMetric:GetTextHeight(tmpText,newWidth)
				else
					item:SetText("")
				end
			elseif v.Type=="Image" then
				item=Turbine.UI.Control()
				item:SetWidth(newWidth)
				item.Image=Turbine.UI.Control()
				item.Image:SetParent(item)
				item.Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				item.Image:SetMouseVisible(false)
				item.Image.ImagePath=v.Path
				item.Image.FileName=v.FileName
				if v.Path~=nil and v.FileName~=nil then
					readerSetImage(item.Image)
					if item.Image.Width>newWidth then
						newHeight=32
					else
						newHeight=item.Image.Height
					end
				else
					item.Image.File=resourcePath.."ImageError.tga"
					item.Image:SetBackground(resourcePath.."ImageError.tga")
					item.Image:SetSize(32,32)
					item.Image.Width=32
					item.Image.Height=32
					newHeight=32
					item.Image:SetLeft((newWidth-item.Image:GetWidth())/2)
				end
				item.MouseDoubleClick=function(sender,args)
					imageViewer.ShowImage(sender.Image.ImagePath,sender.Image.FileName)
				end
			end
			item.Index=k
			item:SetParent(readerWindow.Text)
			item.Type=v.Type
			item.Text=v.Text
			item.FileName=v.FileName
			item.Path=v.Path

			item:SetSize(newWidth,newHeight)
			readerWindow.Text:AddItem(item)
		end
		-- reevaluate all objective statuses
		readerDisplayActiveObjectiveList()

		-- now add callbacks for the current chapter's objectives
		local addTargetCallback=false
		local addBackpackCallback=false
		local addChatCallback=false
		local addItemEquippedCallback=false
		local addEffectCallback=false
		for k,v in pairs(readerStory.Chapters[readerWindow.ActiveChapter].Objectives) do
			if v.Type=="Target" then
				addTargetCallback=true
			elseif v.Type=="AcquireX" then
				addBackpackCallback=true
			elseif (v.Type=="DefeatX" or v.Type=="ReceiveChat" or v.Type=="Location") and (v.Status==nil or v.Status==false) then
				addChatCallback=true
			elseif (v.Type=="Equip") then
				addItemEquippedCallback=true
			elseif (v.Type=="Effect") then
				addEffectCallback=true
			end
		end
		if addTargetCallback then
			table.insert(readerWindow.Callbacks,{["Object"]=localPlayer,["Event"]="TargetChanged",["Function"]=readerWindow.TargetChanged})
			AddCallback(localPlayer,"TargetChanged",readerWindow.TargetChanged)
			readerWindow.TargetChanged()
		end
		if addBackpackCallback then
			readerWindow.BackpackInit()
		end
		if addChatCallback then
			table.insert(readerWindow.Callbacks,{["Object"]=Turbine.Chat,["Event"]="Received",["Function"]=readerWindow.MessageReceived})
			AddCallback(Turbine.Chat,"Received",readerWindow.MessageReceived)
		end
		if addItemEquippedCallback then
			table.insert(readerWindow.Callbacks,{["Object"]=localPlayer.Equipment,["Event"]="ItemEquipped",["Function"]=readerWindow.ItemEquipped})
			AddCallback(localPlayer.Equipment,"ItemEquipped",readerWindow.ItemEquipped)
			checkEquippedItems()
		end
		if addEffectCallback then
			table.insert(readerWindow.Callbacks,{["Object"]=localPlayer.EffectsList,["Event"]="EffectAdded",["Function"]=readerWindow.EffectAdded})
			AddCallback(localPlayer.EffectsList,"EffectAdded",readerWindow.EffectAdded)
			readerWindow.EffectAdded()
		end
	end
	readerWindow.Message:SetText("")
end
readerStartStory=function(firstChapter)
if showTime then Turbine.Shell.WriteLine("readerStartStory:"..tostring(Turbine.Engine:GetLocalTime())) end
	readerWindow.ActiveChapter=firstChapter
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	StoryList[index].ActiveChapter=firstChapter
	StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
	-- need to indicate that we are resetting
	readerWindow.Message:SetText("Setting Status. One Moment...")
	readerWindow.ObjectiveList:ClearItems()
	-- reset all objective statuses
	for k,v in ipairs(readerStory.Chapters) do
		if v.Objectives~=nil then
			for i,obj in pairs(v.Objectives) do
				if type(obj)=="table" then
					-- update cached copy
					obj.Count=nil
					obj.Status=nil
				end
			end
		end
	end
	local cmd="if tmpData.Chapters~=nil then for chapterIndex,chapter in ipairs(tmpData.Chapters) do chapter.Status=false; if chapter.Objectives~=nil then for objIndex,objective in ipairs(chapter.Objectives) do objective.Count=nil;objective.Status=false end end end end"
	SettingQueueCommand("Account",pluginName.."Story"..tostring(readerWindow.currentStoryID),cmd,nil,nil)
	-- need to use callback to delay until status updates take effect
	SettingQueueCallback(readerDisplayActiveChapter)
end
readerDisplayActiveObjectiveList=function()
if showTime then Turbine.Shell.WriteLine("readerDisplayActiveObjectiveList:"..tostring(Turbine.Engine:GetLocalTime())) end
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end
	for k,v in pairs(readerWindow.ObjectiveItems) do
		readerWindow.ObjectiveItems[k]=nil
	end
	for k,v in pairs(readerWindow.ObjectiveMessages) do
		readerWindow.ObjectiveMessages[k]=nil
	end
	for k,v in pairs(readerWindow.ObjectiveEffects) do
		readerWindow.ObjectiveEffects[k]=nil
	end
	readerWindow.ObjectiveList:ClearItems()
	tmpList={}
	for k,v in ipairs(readerStory.Chapters[readerWindow.ActiveChapter].Objectives) do
		table.insert(tmpList,{["ID"]=k,["Name"]=v.Name,["Type"]=v.Type,["Status"]=v.Status,["Count"]=v.Count,["RequiredCount"]=v.RequiredCount,["DisplayOrder"]=v.DisplayOrder,["ObjectiveString"]=v.ObjectiveString,["ObjectiveStringFR"]=v.ObjectiveStringFR,["ObjectiveStringDE"]=v.ObjectiveStringDE,["Text"]=v.Text,["TextFR"]=v.TextFR,["TextDE"]=v.TextDE})
	end
	table.sort(tmpList,function(arg1,arg2) if arg1.DisplayOrder<arg2.DisplayOrder then return true end end)
	for k,v in ipairs(tmpList) do
		-- create the text
		local tmpText
		if Settings.CurrentLanguage==2 then
			if v.TextFR~=nil then
				tmpText=resolveText(v.TextFR)
			else
				tmpText=resolveText(v.Text)
			end
		elseif Settings.CurrentLanguage==3 then
			if v.TextDE~=nil then
				tmpText=resolveText(v.TextDE)
			else
				tmpText=resolveText(v.Text)
			end
		else
			tmpText=resolveText(v.Text)
		end
		local tmpItem=Turbine.UI.Label()
		tmpItem:SetParent(readerWindow.Objectives)
		tmpItem:SetFont(Settings.Font)
		tmpItem:SetWidth(readerWindow.ObjectiveList:GetWidth())
		tmpItem:SetMouseVisible(false)
		fontMetric:SetFont(Settings.Font)
		local height=fontMetric:GetTextHeight(tmpText,tmpItem:GetWidth())
		local height2
		tmpItem:SetText(tmpText)
		-- create checkmark 1091437784
		tmpItem.CheckMark=Turbine.UI.Control()
		tmpItem.CheckMark:SetParent(tmpItem)
		tmpItem.CheckMark:SetMouseVisible(false)
		tmpItem.CheckMark:SetSize(24,18)
		tmpItem.CheckMark:SetPosition(0,height)
		tmpItem.CheckMark:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		tmpItem.CheckMark:SetBackground(1091437784)
		if v.Status then
			tmpItem.CheckMark:SetVisible(true)
			height2=18
		else
			tmpItem.CheckMark:SetVisible(false)
			height2=0
		end
		if v.Type=="Button" then
			-- create button
			tmpItem.Button=Turbine.UI.Lotro.Button()
			tmpItem.Button:SetParent(tmpItem)
			tmpItem.Button:SetFont(buttonFont)
			fontMetric:SetFont(buttonFont)
			tmpItem.Button:SetWidth(fontMetric:GetTextWidth(v.Name)+20)
			tmpItem.Button:SetPosition((readerWindow.ObjectiveList:GetWidth()-tmpItem.Button:GetWidth())/2,height)
			if Settings.CurrentLanguage==2 then
				if v.ObjectiveStringFR~=nil then
					tmpItem.Button:SetText(v.ObjectiveStringFR)
				else
					tmpItem.Button:SetText(v.ObjectiveString)
				end
			elseif Settings.CurrentLanguage==3 then
				if v.ObjectiveStringDE~=nil then
					tmpItem.Button:SetText(v.ObjectiveStringDE)
				else
					tmpItem.Button:SetText(v.ObjectiveString)
				end
			else
				tmpItem.Button:SetText(v.ObjectiveString)
			end
			tmpItem.Button.Click=function() local next=readerUpdateObjectiveStatus(readerWindow.ActiveChapter,v.ID);if next==nil then readerUpdateChapterStatus() else readerGoToChapter(next) end end
			height2=20
		end
		if v.Type=="AcquireX" or v.Type=="DefeatX" then
			-- add .CountLabel
			tmpItem.CountLabel=Turbine.UI.Label()
			tmpItem.CountLabel:SetParent(tmpItem)
			tmpItem.CountLabel:SetSize(tmpItem:GetWidth(),controlHeight)
			tmpItem.CountLabel:SetPosition(0,height)
			tmpItem.CountLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
			tmpItem.CountLabel:SetMouseVisible(false)
			tmpItem.CountLabel:SetFont(Settings.Font)
			if v.Count==nil then v.Count=0 end
			tmpItem.CountLabel:SetText(tostring(v.Count).."/"..tostring(v.RequiredCount))
			if controlHeight>height2 then height2=controlHeight end
		end
		if v.Type=="AcquireX" then
			-- use client language, NOT reader language as this string matches what the client generates
			if language==2 then
				if v.ObjectiveStringFR~=nil then
					table.insert(readerWindow.ObjectiveItems,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveStringFR,["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveItems,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
				end
			elseif language==3 then
				if v.ObjectiveStringDE~=nil then
					table.insert(readerWindow.ObjectiveItems,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveStringDE,["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveItems,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
				end
			else
				table.insert(readerWindow.ObjectiveItems,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
			end
		end
		if v.Type=="DefeatX" and (v.Status==nil or v.Status==false) then
			-- use client language, NOT reader language as this string matches what the client generates
			if language==2 then
				if v.ObjectiveStringFR~=nil then
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=v.RequiredCount,["Channel"]=Turbine.ChatType.Death,["Pattern"]="Votre coup puissant a vaincu.*"..v.ObjectiveStringFR..".*",["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=v.RequiredCount,["Channel"]=Turbine.ChatType.Death,["Pattern"]="Votre coup puissant a vaincu.*"..v.ObjectiveString..".*",["DisplayOrder"]=v.DisplayOrder})
				end
			elseif language==3 then
				if v.ObjectiveStringDE~=nil then
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=v.RequiredCount,["Channel"]=Turbine.ChatType.Death,["Pattern"]="Mit m\195\164chtigem Hieb besiegt.*"..v.ObjectiveStringDE..".*",["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=v.RequiredCount,["Channel"]=Turbine.ChatType.Death,["Pattern"]="Mit m\195\164chtigem Hieb besiegt.*"..v.ObjectiveString..".*",["DisplayOrder"]=v.DisplayOrder})
				end
			else
				table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=v.RequiredCount,["Channel"]=Turbine.ChatType.Death,["Pattern"]="Your mighty blow defeated.*"..v.ObjectiveString..".*",["DisplayOrder"]=v.DisplayOrder})
			end
		end
		if v.Type=="ReceiveChat" and (v.Status==nil or v.Status==false) then
			-- need ID,RequredCount,Channel (from RequiredCount), Pattern (from ObjectiveString), DisplayOrder)
			if Settings.CurrentLanguage==2 then
				if v.ObjectiveStringFR~=nil then
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=0,["Channel"]=v.RequiredCount,["Pattern"]=v.ObjectiveStringFR,["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=0,["Channel"]=v.RequiredCount,["Pattern"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
				end
			elseif Settings.CurrentLanguage==3 then
				if v.ObjectiveStringDE~=nil then
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=0,["Channel"]=v.RequiredCount,["Pattern"]=v.ObjectiveStringDE,["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=0,["Channel"]=v.RequiredCount,["Pattern"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
				end
			else
				table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["RequiredCount"]=0,["Channel"]=v.RequiredCount,["Pattern"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
			end
		end
		if v.Type=="Effect" then
			-- use client language, NOT reader language as this string matches what the client generates
			if language==2 then
				if v.ObjectiveStringFR~=nil then
					table.insert(readerWindow.ObjectiveEffects,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveStringFR,["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveEffects,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
				end
			elseif language==3 then
				if v.ObjectiveStringDE~=nil then
					table.insert(readerWindow.ObjectiveEffects,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveStringDE,["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveEffects,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
				end
			else
				table.insert(readerWindow.ObjectiveEffects,{["ID"]=v.ID,["RequiredCount"]=v.RequiredCount,["Name"]=v.ObjectiveString,["DisplayOrder"]=v.DisplayOrder})
			end
		end
		if v.Type=="Location" and (v.Status==nil or v.Status==false) then
			-- need a button with label Resource[language][222] with /loc, /emp, /pos quickslot under it
			fontMetric:SetFont(buttonFont)
			tmpItem.QS=Turbine.UI.Lotro.Quickslot()
			tmpItem.QS:SetParent(tmpItem)
			tmpItem.QS:SetShortcut()
			tmpItem.QS:SetAllowDrop(false)
			tmpItem.QS:SetSize(fontMetric:GetTextWidth(Resource[language][222])+20,22)
			tmpItem.QS:SetPosition((readerWindow.ObjectiveList:GetWidth()-tmpItem.QS:GetWidth())/2,height)

			tmpItem.QS:SetAllowDrop(false)
			tmpItem.QS.Cmd="/loc"
			if language==2 then
				tmpItem.QS.Cmd="/emp"
			elseif language==3 then
				tmpItem.QS.Cmd="/pos"
			end
			tmpItem.QS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, tmpItem.QS.Cmd));
			tmpItem.QS.DragDrop=function()
				-- reestablish the shortcut if the user accidentally drags it onto itself which wipes it out even if drag/drop is disabled
				tmpItem.QS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, tmpItem.QS.Cmd));
			end

			tmpItem.ButtonBack=Turbine.UI.Control()
			tmpItem.ButtonBack:SetParent(tmpItem)
			tmpItem.ButtonBack:SetSize(tmpItem.QS:GetWidth(),22)
			tmpItem.ButtonBack:SetPosition(tmpItem.QS:GetPosition())
			tmpItem.ButtonBack:SetBackColor(Settings.TrimColor)
			tmpItem.ButtonBack:SetMouseVisible(false)
			tmpItem.ButtonBack:SetZOrder(1)

			tmpItem.LocButton=Turbine.UI.Label()
			tmpItem.LocButton:SetParent(tmpItem.ButtonBack)
			tmpItem.LocButton:SetFont(buttonFont)
			tmpItem.LocButton:SetSize(tmpItem.ButtonBack:GetWidth()-2,tmpItem.ButtonBack:GetHeight()-2)
			tmpItem.LocButton:SetPosition(1,1)
			tmpItem.LocButton:SetMultiline(false)
			tmpItem.LocButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
			tmpItem.LocButton:SetText(Resource[language][222])
			tmpItem.LocButton:SetBackColor(Settings.BackColor)
			tmpItem.LocButton:SetMouseVisible(false)
			height2=22

			-- need ID,RequredCount,Channel (from RequiredCount), Pattern (from ObjectiveString), DisplayOrder)
			-- use client language, NOT reader language as this string matches what the client generates
			if language==2 then
				if v.ObjectiveStringFR~=nil then
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["Region"]=v.RequiredCount,["Location"]=v.ObjectiveString,["RequiredCount"]=0,["Channel"]=Turbine.ChatType.Standard,["Pattern"]="Votre emplacement .*: r.*",["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["Region"]=v.RequiredCount,["Location"]=v.ObjectiveString,["RequiredCount"]=0,["Channel"]=Turbine.ChatType.Standard,["Pattern"]="You are at: r.*",["DisplayOrder"]=v.DisplayOrder})
				end
			elseif language==3 then
				if v.ObjectiveStringDE~=nil then
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["Region"]=v.RequiredCount,["Location"]=v.ObjectiveString,["RequiredCount"]=0,["Channel"]=Turbine.ChatType.Standard,["Pattern"]="Ihr befindet Euch hier: r.*",["DisplayOrder"]=v.DisplayOrder})
				else
					table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["Region"]=v.RequiredCount,["Location"]=v.ObjectiveString,["RequiredCount"]=0,["Channel"]=Turbine.ChatType.Standard,["Pattern"]="You are at: r.*",["DisplayOrder"]=v.DisplayOrder})
				end
			else
				table.insert(readerWindow.ObjectiveMessages,{["ID"]=v.ID,["Type"]=v.Type,["Region"]=v.RequiredCount,["Location"]=v.ObjectiveString,["RequiredCount"]=0,["Channel"]=Turbine.ChatType.Standard,["Pattern"]="You are at: r.*",["DisplayOrder"]=v.DisplayOrder})
			end
		end

		tmpItem:SetHeight(height+height2+controlHeight)
		readerWindow.ObjectiveList:AddItem(tmpItem)
	end
end
readerUpdateObjectiveStatus=function(chapter,obj)
if showTime then Turbine.Shell.WriteLine("readerUpdateObjectiveStatus(obj:"..tostring(obj).."):"..tostring(Turbine.Engine:GetLocalTime())) end
	local nextChapter=nil
	if chapter==nil then chapter=readerWindow.ActiveChapter end
	local objective=readerStory.Chapters[chapter].Objectives[obj]
	if objective.Type=="Button" then
		objective.Status=true
		nextChapter=objective.NextChapter -- objectives can optionally change chapter immediately on completion or combine
	elseif objective.Type=="Target" then
		if objective.Status then
			nextChapter=objective.NextChapter
		end
	elseif objective.Type=="AcquireX" or objective.Type=="DefeatX" then
		local olItem=readerWindow.ObjectiveList:GetItem(objective.DisplayOrder)
		if olItem.CountLabel~=nil then
			if objective.Count==nil then objective.Count=0 end
			olItem.CountLabel:SetText(tostring(objective.Count).."/"..tostring(objective.RequiredCount))
		end
		if objective.Count~=nil and objective.Count>=objective.RequiredCount then
			objective.Status=true
			nextChapter=objective.NextChapter -- objectives can optionally change chapter immediately on completion or combine
		else
			objective.Status=false
		end
	elseif objective.Type=="Equip" or objective.Type=="Effect" then
		-- status is immediately updated in the event handler since there is no count
		if objective.Status then
			nextChapter=objective.NextChapter -- objectives can optionally change chapter immediately on completion or combine
		end
	end

	local tmpItem=readerWindow.ObjectiveList:GetItem(objective.DisplayOrder)
	local tmpHeight=tmpItem:GetHeight()
	if tmpItem.CountLabel~=nil then
		tmpItem.CountLabel:SetText(tostring(objective.Count).." / "..tostring(objective.RequiredCount))
	end
	local checkHeight=0
	if tmpItem.CountLabel==nil and tmpItem.Button==nil then
		checkHeight=18
		if tmpItem.CheckMark:IsVisible() then
			tmpHeight=tmpHeight-checkHeight
		end
	end

	if objective.Status then
		if objective.Type=="Location" then
			tmpItem.QS:SetVisible(false)
			tmpItem.ButtonBack:SetVisible(false)
		end
		tmpItem.CheckMark:SetVisible(true)
		tmpItem:SetHeight(tmpHeight+checkHeight)
	else
		tmpItem.CheckMark:SetVisible(false)
		tmpItem:SetHeight(tmpHeight)
	end

	return nextChapter
end
readerUpdateChapterStatus=function()
if showTime then Turbine.Shell.WriteLine("readerUpdateChapterStatus:"..tostring(Turbine.Engine:GetLocalTime())) end
 -- check for success condition and if all objectives are met, then move on to next chapter
	local condition=readerStory.Chapters[readerWindow.ActiveChapter].SuccessCondition
	local status=false
	if condition~=nil then
		if type(condition)=="number" then
			status=readerStory.Chapters[readerWindow.ActiveChapter].Objectives[condition].Status
		elseif type(condition)=="table" then
			status=true
			for k,v in ipairs(condition) do
				status=(status and readerStory.Chapters[readerWindow.ActiveChapter].Objectives[v].Status)
			end
		end
	end
	if status then
		readerStory.Chapters[readerWindow.ActiveChapter].Status=true
		readerGoToChapter(readerStory.Chapters[readerWindow.ActiveChapter].SuccessNextChapter)
	else
		condition=readerStory.Chapters[readerWindow.ActiveChapter].FailCondition
		if condition~=nil then
			if type(condition)=="number" then
				status=readerStory.Chapters[readerWindow.ActiveChapter].Objectives[condition].Status
			elseif type(condition)=="table" then
				status=true
				for k,v in ipairs(condition) do
					status=(status and readerStory.Chapters[readerWindow.ActiveChapter].Objectives[v].Status)
				end
			end
		end
		readerStory.Chapters[readerWindow.ActiveChapter].Status=status
		if status then
			readerGoToChapter(readerStory.Chapters[readerWindow.ActiveChapter].FailNextChapter)
		end
	end
	return status
end
readerGoToChapter=function(chapter)
	readerWindow.ActiveChapter=chapter
--Turbine.Shell.WriteLine("going to chapter:"..tostring(chapter))
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	if readerWindow.ActiveChapter>0 then
		readerStory.Chapters[readerWindow.ActiveChapter].Status=false
		for k,v in ipairs(readerStory.Chapters[readerWindow.ActiveChapter].Objectives) do
			if v.Count~=nil then v.Count=0 end
			v.Status=false
		end
		StoryList[index].ActiveChapter=readerWindow.ActiveChapter
		StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
		readerDisplayActiveChapter()
	else
		StoryList[index].ActiveChapter=nil
		readerDisplayStory()
	end
end
readerWindow.StoryDeleted=function(ID)
	if readerWindow.currentStoryID==ID then
		readerWindow.currentStoryID=nil
		if not readerWindow.Paused then
			for k,v in pairs(readerWindow.Callbacks) do
				if v.Object~=nil then
					RemoveCallback(v.Object,v.Event,v.Function)
				end
			end
		else
			readerWindow.Paused=false
			readerWindow.LoadButton:SetEnabled(true)
			readerWindow.ResetButton:SetEnabled(true)
			readerWindow.HistoryButton:SetEnabled(true)
		end
		readerWindow.Story:SetText("")
		readerWindow.Chapter:SetText("")
		readerWindow.Text:ClearItems()
		readerWindow.ObjectiveList:ClearItems()
	end
end

-- OBJECTIVE TRACKER
objectiveTracker=Turbine.UI.Lotro.Window()
objectiveTracker:SetResizable(true)
objectiveTracker:SetMinimumSize(displayWidth*.2,90)
objectiveTracker:SetMouseVisible(false)
objectiveTracker:SetText(Resource[language][2].." - "..Resource[language][234])
--objectiveTracker:SetWantsKeyEvents(true)
objectiveTracker.SizeChanged=function(sender,args)
	readerWindow:RefreshObjectives()
end
--objectiveTracker.KeyDown=function()
--	if objectiveTracker:IsControlDown() then
--		objectiveTracker:SetMouseVisible(true)
--	else
--		objectiveTracker:SetMouseVisible(false)
--	end
--end
--objectiveTracker.KeyUp=function()
--	if objectiveTracker:IsControlDown() then
--		objectiveTracker:SetMouseVisible(true)
--	else
--		objectiveTracker:SetMouseVisible(false)
--	end
--end

if ReaderSettings.ObjectiveOpacity==nil then
	ReaderSettings.ObjectiveOpacity=.7
end
if ReaderSettings.ObjectiveTracker==nil then ReaderSettings.ObjectiveTracker={} end
if ReaderSettings.ObjectiveTracker.Width==nil then
	ReaderSettings.ObjectiveTracker.Width=.2
end
if ReaderSettings.ObjectiveTracker.Height==nil then
	ReaderSettings.ObjectiveTracker.Height=.4
end
if ReaderSettings.ObjectiveTracker.Top==nil then
	ReaderSettings.ObjectiveTracker.Top=(1-ReaderSettings.ObjectiveTracker.Height)/2
end
if ReaderSettings.ObjectiveTracker.Left==nil then
	ReaderSettings.ObjectiveTracker.Left=(1-ReaderSettings.ObjectiveTracker.Height)/2
end
if ReaderSettings.ObjectiveTracker.Width<(objectiveTracker:GetMinimumWidth()/displayWidth) then ReaderSettings.ObjectiveTracker.Width=objectiveTracker:GetMinimumWidth()/displayWidth end
if ReaderSettings.ObjectiveTracker.Height<(objectiveTracker:GetMinimumHeight()/displayHeight) then ReaderSettings.ObjectiveTracker.Height=objectiveTracker:GetMinimumHeight()/displayWidth end
objectiveTracker:SetSize(ReaderSettings.ObjectiveTracker.Width*displayWidth,ReaderSettings.ObjectiveTracker.Height*displayHeight)
objectiveTracker:SetPosition(ReaderSettings.ObjectiveTracker.Left*displayWidth,ReaderSettings.ObjectiveTracker.Top*displayHeight)
objectiveTracker:SetOpacity(ReaderSettings.ObjectiveOpacity)

-- OBJECTIVE CALLBACKS
readerWindow.TargetChanged=function()
	-- registered for TargetChanged
	if readerWindow.ActiveChapter~=nil then
		local next
		local target=localPlayer:GetTarget()
		if target~=nil then
			local name=target:GetName()
			local objectives=readerStory.Chapters[readerWindow.ActiveChapter].Objectives
			if objectives~=nil then
				for k,v in pairs(objectives) do
					if v.Type=="Target" then
						local tmpName
						if language==2 then
							tmpName=resolveText(v.ObjectiveStringFR)
						elseif language==3 then
							tmpName=resolveText(v.ObjectiveStringDE)
						else
							tmpName=resolveText(v.ObjectiveString)
						end
						if name==tmpName then
							v.Status=true
-- do we want persistent target objectives?
-- without persistent targets then the objective status goes back to false as soon as you change targets - this is good if another objective depends on this target
-- however, that eliminates having multiple "find person x" type objectives in a single chapter
-- since it has no count, we will keep it as persistent for consistency (so far only objectives with a count are non-persistent)
-- enable the next two lines to make target objectives non-persistent
--						else
--							v.Status=false
						end
						local tmpNext=readerUpdateObjectiveStatus(readerWindow.ActiveStory,k)
						if tmpNext~=nil then next=tmpNext end
					end
				end
			end
		end
		if next==nil then
			readerUpdateChapterStatus()
		else
			readerGoToChapter(next)
		end
	end
end
readerWindow.BackpackItemAdded=function(sender,args)
	local tmpName=args.Item:GetName()
	for k,v in pairs(readerWindow.ObjectiveItems) do
		if v.Name==tmpName then
			table.insert(readerWindow.Callbacks,{["Object"]=args.Item,["Event"]="QuantityChanged",["Function"]=readerWindow.BackpackQuantityChanged})
			AddCallback(args.Item,"QuantityChanged",readerWindow.BackpackQuantityChanged)
			SettingQueueCallback(readerWindow.BackpackUpdateQuantity) -- call the update with a callback to avoid stack merge missing event issues
		end
	end
end
readerWindow.BackpackItemRemoved=function(sender,args)
	-- since we can't easily determine the item removed, just treat it the same as any other quantity update. this will handle stack merges, vendoring, vault, etc.
	-- it's a brute force approach but it is better then the overhead of accurately tracking all of the items in the backpack (no need for a whole inventory for this)
	SettingQueueCallback(readerWindow.BackpackUpdateQuantity) -- call the update with a callback
end
readerWindow.BackpackInit=function()
	-- check backpack items against objectives and add event handlers when needed
	if readerWindow.ActiveChapter~=nil then
		if #readerWindow.ObjectiveItems>0 then
			-- now loop through backpack looking for any matches to readerWindow.ObjectiveItems to advance
			local itemFound=false
			for index=1,localPlayer.Backpack:GetSize() do
				local tmpItem=localPlayer.Backpack:GetItem(index)
				if tmpItem~=nil then
					local tmpName=tmpItem:GetName()
					for k,v in pairs(readerWindow.ObjectiveItems) do
						if v.Name==tmpName then
							-- add a quantitychanged handler for this item
							table.insert(readerWindow.Callbacks,{["Object"]=tmpItem,["Event"]="QuantityChanged",["Function"]=readerWindow.BackpackQuantityChanged})
							AddCallback(tmpItem,"QuantityChanged",readerWindow.BackpackQuantityChanged)
							itemFound=true
						end
					end
				end
			end
			if itemFound then
				readerWindow.BackpackQuantityChanged()
			end
			table.insert(readerWindow.Callbacks,{["Object"]=localPlayer.Backpack,["Event"]="ItemAdded",["Function"]=readerWindow.BackpackItemAdded})
			AddCallback(localPlayer.Backpack,"ItemAdded",readerWindow.BackpackItemAdded)
			table.insert(readerWindow.Callbacks,{["Object"]=localPlayer.Backpack,["Event"]="ItemRemoved",["Function"]=readerWindow.BackpackItemRemoved})
			AddCallback(localPlayer.Backpack,"ItemRemoved",readerWindow.BackpackItemRemoved)
		end
	end
end
readerWindow.BackpackQuantityChanged=function()
	-- use callback to avoid stack splitting and missing event issues
	SettingQueueCallback(readerWindow.BackpackUpdateQuantity)
end
readerWindow.BackpackUpdateQuantity=function()
	-- this fires anytime a backpack item with a name in our list has a quantity change
	-- we scan the entire backpack for items on the list in case there are multiple stacks
	if readerWindow.ActiveChapter~=nil then
		if #readerWindow.ObjectiveItems>0 then
			for k,v in ipairs(readerWindow.ObjectiveItems) do
				readerWindow.ObjectiveItems[k].Qty=0
			end
			for index=1,localPlayer.Backpack:GetSize() do
				local tmpItem=localPlayer.Backpack:GetItem(index)
				if tmpItem~=nil then
					local tmpName=tmpItem:GetName()
					for k,v in pairs(readerWindow.ObjectiveItems) do
						if v.Name==tmpName then
							readerWindow.ObjectiveItems[k].Qty=readerWindow.ObjectiveItems[k].Qty+tmpItem:GetQuantity()
						end
					end
				end
			end
			-- now update objectives
			local next
			local objectives=readerStory.Chapters[readerWindow.ActiveChapter].Objectives
			for k,v in ipairs(readerWindow.ObjectiveItems) do
				objectives[v.ID].Count=v.Qty
				objectives[v.ID].Status=(v.Qty>=objectives[v.ID].RequiredCount)
				local tmpNext=readerUpdateObjectiveStatus(readerWindow.ActiveStory,v.ID)
				if tmpNext~=nil then next=tmpNext end
			end
			if next==nil then
				readerUpdateChapterStatus()
			else
				readerGoToChapter(next)
			end
		end
	end
end

readerWindow.MessageReceived=function(sender,args)
-- DefeatX is a special case of this with a specific message, specific channel and a count - why not allow count for any message?
-- Emote is a special case of this with a specific message and channel - perhaps a count as well
	if readerWindow.ActiveChapter~=nil then
		if #readerWindow.ObjectiveMessages>0 then
			-- check incomming message versus objectivemessages
			local next
			local objectives=readerStory.Chapters[readerWindow.ActiveChapter].Objectives
			for k,v in ipairs(readerWindow.ObjectiveMessages) do
				if (args.ChatType==0 or args.ChatType==v.Channel) then
					local message=string.sub(args.Message,1,-2)
					local match=true
					if string.match(message,v.Pattern)~=nil then
						if v.Type=="Location" then
							-- we received a /loc message, now need to compare co-ordinates
							match=false
							if language==2 then
								locationString="Votre emplacement .*: r.*"
								headingString="Votre emplacement .*: r.* h.*"
								patternString1="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
								patternString2="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
								patternString3="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
								patternString4="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
							elseif language==3 then
								locationString="Ihr befindet Euch hier: r.*"
								headingString="Ihr befindet Euch hier: r.* h.*"
								patternString1="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
								patternString2="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
								patternString3="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
								patternString4="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
							else
								locationString="You are at: r.*"
								headingString="You are at: r.* h.*"
								patternString1="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
								patternString2="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
								patternString3="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
								patternString4="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
							end
							if string.find(args.Message,locationString)~=nil then
								local region, lx, ly, ox, oy, oz, heading;
								if string.find(args.Message,headingString)==nil then
									heading=0;
									region, lx, ly, ox, oy, oz = string.match(args.Message,patternString1);
									if region==nil then
										--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
										region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2);
										if region==nil then
											region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3);
											if region==nil then
												region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4);
											end
										end
									end
								else
									region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString1.." h(%d+%.?%d*)");
									if region==nil then
										--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
										region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2.." h(%d+%.?%d*)");
										if region==nil then
											region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3.." h(%d+%.?%d*)");
											if region==nil then
												region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4.." h(%d+%.?%d*).*");
											end
										end
									end
								end
								if region ~= nil then
									if heading ==nil then
										-- when facing north the heading value is not present
										heading=0
									end
									region=tonumber(region);
									ox=euroNormalize(ox);
									oy=euroNormalize(oy);
									oz=euroNormalize(oz);
									heading=euroNormalize(heading);
									local ew=math.floor((( math.floor( lx / 8 ) * 160 + ox ) - 29360) / 20 +.5)/10
									local ns=math.floor((( math.floor( ly / 8 ) * 160 + oy ) - 24880) / 20 +.5)/10
									if region==v.Region and v.Location~=nil and v.Location==(tostring(ns)..", "..tostring(ew)) then match=true end
								end
							end
						end
						if match then
							if v.RequiredCount>0 then
								if objectives[v.ID].Count==nil then
									objectives[v.ID].Count=1
								else
									objectives[v.ID].Count=objectives[v.ID].Count+1
								end
								objectives[v.ID].Status=(objectives[v.ID].Count>=objectives[v.ID].RequiredCount)
							else
								objectives[v.ID].Status=true
							end
							-- update objective status
							local tmpNext=readerUpdateObjectiveStatus(readerWindow.ActiveStory,v.ID)
							if tmpNext~=nil then next=tmpNext end
							if objectives[v.ID].Status==true then
								table.remove(readerWindow.ObjectiveMessages,k)
							end
						end
					end
				end
			end
			if next==nil then
				readerUpdateChapterStatus()
			else
				readerGoToChapter(next)
			end
		end
	end
end

readerWindow.ItemEquipped=function(sender,args)
	local item=args.Item
	if readerWindow.ActiveChapter~=nil and item~=nil then
		local objectives=readerStory.Chapters[readerWindow.ActiveChapter].Objectives
		local next
		local itemName=item:GetName()
		for k,v in ipairs(readerStory.Chapters[readerWindow.ActiveChapter].Objectives) do
			if v.Type=="Equip" then
				local tmpName
				if lanugage==2 then
					tmpName=v.ObjectiveStringFR
				elseif language==3 then
					tmpName=v.ObjectiveStringDE
				else
					tmpName=v.ObjectiveString
				end
				if itemName==tmpName then
					-- this objective matched
					v.Status=true
					-- update objective status
					local tmpNext=readerUpdateObjectiveStatus(readerWindow.ActiveStory,k)
					if tmpNext~=nil then next=tmpNext end
				end
			end
		end
		if next==nil then
			readerUpdateChapterStatus()
		else
			readerGoToChapter(next)
		end
	end
end
readerWindow.EffectAdded=function()
	-- can't use Contains since we can only match by name so we have to scan the whole table
	if localPlayer.EffectsList~=nil then
		if readerWindow.ObjectiveEffects~=nil and #readerWindow.ObjectiveEffects>0 then
			local next
			for index=1,localPlayer.EffectsList:GetCount() do
				local effect=localPlayer.EffectsList:Get(index)
				if effect~=nil then
					local effectName=effect:GetName()
					if effectName~=nil then
						for k,v in ipairs(readerWindow.ObjectiveEffects) do
							if v.Name==effectName then
								readerStory.Chapters[readerWindow.ActiveChapter].Objectives[v.ID].Status=true
								local tmpNext=readerUpdateObjectiveStatus(readerWindow.ActiveStory,v.ID)
								if tmpNext~=nil then next=tmpNext end
							end
						end
					end
				end
			end
			if next==nil then
				readerUpdateChapterStatus()
			else
				readerGoToChapter(next)
			end			
		end
	end
	
	-- registered for EffectAdded, EffectRemoved and EffectsCleared
end
readerWindow.WalletChanged=function()
	-- registered for Wallet:ItemAdded, ItemRemoved
end
checkEquippedItems=function()
	-- called whenever we load a chapter with an "Equip" objective - need to scan all equipped items to see if the required item is already equipped
	local next
	for index=1,localPlayer.Equipment:GetSize() do
		local item=localPlayer.Equipment:GetItem(index)
		if item~=nil then
			local itemName=item:GetName()
			local objectives=readerStory.Chapters[readerWindow.ActiveChapter].Objectives
			for k,v in ipairs(objectives) do
				if v.Type=="Equip" then
					local tmpName
					if lanugage==2 then
						tmpName=v.ObjectiveStringFR
					elseif language==3 then
						tmpName=v.ObjectiveStringDE
					else
						tmpName=v.ObjectiveString
					end
					if itemName==tmpName then
						-- this objective matched
						v.Status=true
						-- update objective status
						local tmpNext=readerUpdateObjectiveStatus(readerWindow.ActiveStory,k)
						if tmpNext~=nil then next=tmpNext end
					end
				end
			end
		end
	end
	if next==nil then
		readerUpdateChapterStatus()
	else
		readerGoToChapter(next)
	end
end

-- END OF Callbacks
languagePopUpOK=function()
	languagePopUp=nil
end
readerWindow.CloseInfo=function()
	readerWindow.MouseMask:SetMouseVisible(false)
	infoPopUp=nil
end
readerWindow.CloseError=function()
	readerWindow.MouseMask:SetMouseVisible(false)
	errorMsg=nil
end
readerWindow:SetVisible(true)
currentWindow=readerWindow

unloadMain=function()
	success,result=pcall(Turbine.PluginManager.UnloadScriptState,"Anthology");
end
SettingQueueCallback(unloadMain)
plugin.Unload=function()
	-- remove callbacks
	for k,v in pairs(readerWindow.Callbacks) do
		if v.Object~=nil then
			RemoveCallback(v.Object,v.Event,v.Function)
		end
	end

	ReaderSettings.ReaderWindow.Width=readerWindow:GetWidth()/displayWidth
	ReaderSettings.ReaderWindow.Height=readerWindow:GetHeight()/displayHeight
	ReaderSettings.ReaderWindow.Top=readerWindow:GetTop()/displayHeight
	ReaderSettings.ReaderWindow.Left=readerWindow:GetLeft()/displayWidth

	ReaderSettings.ObjectiveTracker.Width=objectiveTracker:GetWidth()/displayWidth
	ReaderSettings.ObjectiveTracker.Height=objectiveTracker:GetHeight()/displayHeight
	ReaderSettings.ObjectiveTracker.Top=objectiveTracker:GetTop()/displayHeight
	ReaderSettings.ObjectiveTracker.Left=objectiveTracker:GetLeft()/displayWidth
	ReaderSettings.ObjectiveOpacity=objectiveTracker:GetOpacity()

	PatchDataSave(Turbine.DataScope.Account, pluginName.."ReaderSettings",ReaderSettings)

	if readerWindow.currentStoryID~=nil and readerWindow.currentStoryID>0 then
		PatchDataSave(Turbine.DataScope.Account,pluginName.."Story"..readerWindow.currentStoryID,readerStory)
	end
	--save storylist
	PatchDataSave( Turbine.DataScope.Account, pluginName.."StoryList",StoryList);
end
resolveText=function(string)
	if string==nil then
		string=""
	else
		-- @PlayerName
		string=string.gsub(string,"@PlayerName",localPlayer.Name)
		-- @Target
		local target=localPlayer:GetTarget()
		if tarbet~=nil then
			string=string.gsub(string,"@Target",target:GetName())
		else
			string=string.gsub(string,"@Target","??")
		end
		-- @PlayerClass
		string=string.gsub(string,"@PlayerClass",localPlayer.ClassName)
		-- @PlayerRace
		string=string.gsub(string,"@PlayerRace",localPlayer.RaceName)
	end
	return string
end
-- show current story
if readerWindow.currentStoryID~=nil and readerWindow.currentStoryID>0 then
	readerCheckTimeStamps()
end
if showTime then Turbine.Shell.WriteLine("Reader.lua parsed and executed"..tostring(Turbine.Engine:GetLocalTime())) end